####################################################################################

global ModName
global ModDesc
global ModVersion
global ModAuthor
global ModAuthorInfo
global NewFiles
global RepFiles
global MakeDirs

####################################################################################
# Mod Info
####################################################################################

# Mod Name
ModName          = "FugitiveI"
# Mod Description
import Language
if Language.Current == 'Spanish':
	ModDesc = (
		"""Con la subida del da el peligro viene desconocido..."""
		)
else:
	ModDesc = (
		"""With the rising of the day comes danger unknown..."""
		)

# Mod Version
ModVersion       = "1.3"
# Author name
ModAuthor        = "ProsperoProductions"
# Author info: email, url,...
ModAuthorInfo    = "peterrobinsonfineart@btinternet.com"

####################################################################################
# Mod Data
####################################################################################

# Make new directories

MakeDirs = ['../FugitiveI', 
	    '../FugitiveI/Spanish']
          

# New Files added by Mod and destination directory


NewFiles[0]      = {'File': 'pj.py'                                       ,	'Dest': '../FugitiveI'}
NewFiles[1]      = {'File': 'DefFuncs.py'                                 ,	'Dest': '../FugitiveI'}
NewFiles[2]      = {'File': 'cfg.py'                                      ,	'Dest': '../FugitiveI'}
NewFiles[3]      = {'File': 'FugitiveI.lvl'                               ,   'Dest': '../FugitiveI'}
NewFiles[4]      = {'File': 'Blade_progress.jpg'                          ,   'Dest': '../FugitiveI'}
NewFiles[5]      = {'File': 'Blade_progress2.jpg'                         ,   'Dest': '../FugitiveI'}
NewFiles[6]      = {'File': 'Spanish/Blade_progress.jpg'                  ,   'Dest': '../FugitiveI//Spanish'}
NewFiles[7]      = {'File': '/Spanish/Blade_progress2.jpg'                ,   'Dest': '../FugitiveI/Spanish'}
NewFiles[8]      = {'File': 'castle.mmp'                                  ,   'Dest': '../FugitiveI'}
NewFiles[9]      = {'File': 'castle.bw'                                   ,   'Dest': '../FugitiveI'}
NewFiles[10]     = {'File': 'TextureMaterials.py'                         ,   'Dest': '../FugitiveI'}
NewFiles[11]     = {'File': 'enemcast.py'                                 ,   'Dest': '../FugitiveI'}
NewFiles[12]     = {'File': 'bodies.py'                                   ,   'Dest': '../FugitiveI'}
NewFiles[13]     = {'File': 'collapse.py'                                 ,   'Dest': '../FugitiveI'}
NewFiles[14]     = {'File': 'cuervos.py'                                  ,   'Dest': '../FugitiveI'}
NewFiles[15]     = {'File': 'dadada.wav'                                  ,   'Dest': '../FugitiveI'}
NewFiles[16]     = {'File': 'FugitiveIMenu/FugitiveIMenu.py'              ,   'Dest': '../../Scripts'}
NewFiles[17]     = {'File': 'FugitiveIMenu/FugitiveIMenu.bmp'             ,   'Dest': '../FugitiveI'}
NewFiles[18]     = {'File': 'def_class.py'                                ,   'Dest': '../FugitiveI'}
NewFiles[19]     = {'File': 'Dome13.mmp'                                  ,   'Dest': '../FugitiveI'}
NewFiles[20]     = {'File': 'ExTypes.py'                                  ,   'Dest': '../FugitiveI'}
NewFiles[21]     = {'File': 'food.py'                                     ,   'Dest': '../FugitiveI'}
NewFiles[22]     = {'File': 'forge.py'                                    ,   'Dest': '../FugitiveI'}
NewFiles[23]     = {'File': 'gates.py'                                    ,   'Dest': '../FugitiveI'}
NewFiles[24]     = {'File': 'Ghosect.py'                                  ,   'Dest': '../FugitiveI'}
NewFiles[25]     = {'File': 'lava.py'                                     ,   'Dest': '../FugitiveI'}
NewFiles[26]     = {'File': 'lift.py'                                     ,   'Dest': '../FugitiveI'}
NewFiles[27]     = {'File': 'magix.py'                                    ,   'Dest': '../FugitiveI'}
NewFiles[28]     = {'File': 'DefAnims.py'                                 ,   'Dest': '../FugitiveI'}
NewFiles[29]     = {'File': 'necro.py'                                    ,   'Dest': '../FugitiveI'}
NewFiles[30]     = {'File': 'objs.py'                                     ,   'Dest': '../FugitiveI'}
NewFiles[31]     = {'File': 'puertas.py'                                  ,   'Dest': '../FugitiveI'}
NewFiles[32]     = {'File': 'skelgen.py'                                  ,   'Dest': '../FugitiveI'}
NewFiles[33]     = {'File': 'sonidos.py'                                  ,   'Dest': '../FugitiveI'}
NewFiles[34]     = {'File': 'soundFX.sf'                                  ,   'Dest': '../FugitiveI'}
NewFiles[35]     = {'File': 'stores.py'                                   ,   'Dest': '../FugitiveI'}
NewFiles[36]     = {'File': 'agua.py'                                     ,   'Dest': '../FugitiveI'}
NewFiles[37]     = {'File': 'weapons.py'                                  ,   'Dest': '../FugitiveI'}
NewFiles[38]     = {'File': 'ActorsInit.py'                               ,   'Dest': '../FugitiveI'}
NewFiles[39]     = {'File': 'Boss.py'                                     ,   'Dest': '../FugitiveI'}
NewFiles[40]     = {'File': 'cam.py'                                      ,   'Dest': '../FugitiveI'}
NewFiles[41]     = {'File': 'cascada.py'                                  ,   'Dest': '../FugitiveI'}
NewFiles[42]     = {'File': 'MusicEvents.py'                              ,   'Dest': '../FugitiveI'}
NewFiles[43]     = {'File': 'triggsect.py'                                ,   'Dest': '../FugitiveI'}
NewFiles[44]     = {'File': 'QuiverTypes.py'                              ,   'Dest': '../FugitiveI'}
NewFiles[45]     = {'File': 'Positions.py'                                ,   'Dest': '../FugitiveI'}
NewFiles[46]     = {'File': 'Ubarb.bmp'                                   ,   'Dest': '../FugitiveI'}
NewFiles[47]     = {'File': 'vampwp.mmp'                                  ,   'Dest': '../FugitiveI'}
NewFiles[48]     = {'File': 'drown.sf'                                    ,   'Dest': '../FugitiveI'}
NewFiles[49]     = {'File': 'obj_def.py'                                  ,   'Dest': '../FugitiveI'}
NewFiles[50]     = {'File': 'InitNewChars.py'                             ,   'Dest': '../FugitiveI'}
NewFiles[51]     = {'File': 'title.py'                                    ,   'Dest': '../FugitiveI'}

                
inststuff=0

if inststuff==0:
	execfile("../../BODLoader/Mods/FugitiveI/Installnewstuff.py")
      	instuff=1


                     
   
                     
                     
   
                     
   
                     
       
            
                     
                    
            
                     
                    
            
                     
                    
            
                     
                    
            
                     
                    
            
                     
                    
            
                     
                    
            
                     
                    
            
                     
                    
            
                     
                     