import Bladex
import ObjStore
import EnemyTypes
import Enm_Def
import Reference
import AniSound
import Sounds
import Combat
import copy
import Actions
import GameStateAux
import Language
import ItemTypes
import Auras
import Sparks
import GenFX
import Breakings
import Damage
import netgame
import B3DLib
import BCopy
import InitDataField
import Objects
import whrandom
import math
import AuxFuncs
import CharStats
import pdb
import ItemTypes
import Actions
import BUIx
import Change

TRUE=(1==1)
FALSE=(1!=1)

class GladiatorTravelBook(BUIx.B_RectWidget):
	def __init__(self,Parent,Menudesc,StackMenu,VertPos=0):
		import Language
		import Raster
		self.index = 1
		self.images = []
		self.vidw = 1
		self.vidh = 1
		char = Bladex.GetEntity("Player1")
		Raster.UnifyRenderBuffers()
		self.AddImage("..\\..\\Data\\TB\\" + Language.Current + "\\" + char.Kind + "\\plantillaspecials.jpg")
		self.AddImage("..\\..\\Data\\TB\\" + Language.Current + "\\" + char.Kind + "\\plantillaweapons.jpg")
		self.AddImage("..\\..\\Data\\TB\\" + Language.Current + "\\" + char.Kind + "\\plantillahabilities.jpg")
		self.AddImage("..\\..\\Data\\TB\\" + Language.Current +"\\Items\\plantillaGitems.jpg")
		BUIx.B_RectWidget.__init__(self,Parent,Menudesc["Name"],self.vidw,self.vidh)
		self.Selected=0
		self.Solid=0
		self.Border=0
		self.SetDrawFunc(self.Draw)
		self.SndCorreGema=Bladex.CreateSound("..\\..\\Sounds\\golpe-2.wav","Chanje")
		self.SndCorreGema.Volume=0.5
		self.SndCorreGema.MinDistance=1000000.0
		self.SndCorreGema.MaxDistance=2000000


	def AddImage(self, file):
		import BBLib
		image = BBLib.B_BitMap24()
		image.ReadFromFile(file)
		self.images.append(image)


	def Draw(self,x,y,time):
		import Menu
		import Raster
		char = Bladex.GetEntity("Player1")
		x,y = Raster.GetSize()
		Raster.SetPosition((x - 640)/2, (y - 480)/2)
		if self.index < 0:
			self.index = len(self.images) - 1
		if self.index > len(self.images) - 1:
			self.index = 0
		Raster.DrawImage(640,480,"BGR","Normal",self.images[self.index].GetData())
		self.DefDraw(x,y,time)

	def FinalRelease(self):
		BUIx.B_RectWidget.FinalRelease(self)

	def AcceptsFocus(self):
		return 1

	def IncMenuItem(self):
		self.SndCorreGema.PlayStereo()
		self.index = self.index + 1

	def DecMenuItem(self):
		self.SndCorreGema.PlayStereo()
		self.index = self.index - 1

	def GetFocus(self):
	    return self

	def ActivateItem(self,activate):
		import Menu
		Menu.ActivateMenu()


def ExecTravelBook():
	print("travel book activated")
	import Menu
	import GameText
	import Scorer
	import acts
	GameText.AbortText()
	if not Menu.MENU_PREACTIVATED:
		try:
			Menu.TB_ACTIVATED=1
		except:
			pass
		Menu.MENU_PREACTIVATED = 1
		pepote = Menu.Desc1
		Menu.Desc1={"Name":"TopMenu","FrameKind":GladiatorTravelBook,"ListDescr":[{"Name":"Back","Kind":GladiatorTravelBook}]}
		Menu.ActivateMenu()
		Menu.Desc1 = pepote
		Scorer.HideTBS()
		for kn in acts.GetKeyList("Turn Left"):
			if kn!="Left":
				Bladex.AssocKey("Menu Dec","Keyboard",kn)
		for kn in acts.GetKeyList("Turn Right"):
			if kn!="Right":
				Bladex.AssocKey("Menu Inc","Keyboard",kn)
	
	
				
# Dropping Bows 8/)
	
def TryDropLeftBow (EntityName):
	me = Bladex.GetEntity(EntityName)
	statL=Actions.StatL(me.Name)
	statR=Actions.StatR(me.Name)
	if statL == Actions.LA_BOW:
		print "Bow in left hand - try drop"
		inv=me.GetInventory()
		if me.InvRight and Reference.GiveObjectFlag(me.InvRight)==Reference.OBJ_ARROW:
			Actions.SheatheArrow(inv, me.InvRight)
		object = Bladex.GetEntity(me.InvLeft)
		object.ExcludeHitFor(me)
		me.AddAnmEventFunc("DropLeftEvent",Actions.DropReleaseEventHandler)
		Bladex.AddScheduledFunc(Bladex.GetTime()+0.0,me.LaunchAnmType,("drp_l",))
		return TRUE
		print"I have dropped a bow"
	elif statL <> Actions.LA_NO_WEAPON:
		object = Bladex.GetEntity(me.InvLeft)
		if Actions.IsValidForDropping (object.Name):
			object.ExcludeHitFor(me)
			me.AddAnmEventFunc("DropLeftEvent",Actions.DropReleaseEventHandler)
			me.LaunchAnmType("drp_l")
			return TRUE
			print"dropping Shield?"
		else:
			ReportMsg ("Cannot be dropped")
	else:
		return FALSE

	
	
def CheckDropBow(EntityName):
	me = Bladex.GetEntity(EntityName)
	throw_pressed = Bladex.GetTimeActionHeld ("Throw")
	if not throw_pressed:
		return
	TryDropLeftBow (EntityName)
	

	
def EnableTravelBook():
	Bladex.AddBoundFunc("LaunchTravel",ExecTravelBook)
	import acts
	Bladex.AddBoundFunc("Throw Left",acts.DefArgWrapper ("Player1", CheckDropBow))
	Bladex.AddBoundFunc("Block",acts.DefArgWrapper ("Player1", CheckDropBow))
	Bladex.RemoveBoundFunc("LaunchTravel",acts.ExecTravelBookNP)
	Bladex.RemoveBoundFunc("Throw Left",Actions.TestThrowLeft)
	Bladex.RemoveBoundFunc("Block",Actions.TestThrowLeft)
	print"TRAVEL BOOK ENABLED"
	
	

class BoomerangWeapon(ItemTypes.PersistantItemType):
	Name=""
	Speed= 15000.0
	Spin= -0.8
	Axis= (1.0, 0.0, 0.0)
	OwnerName= "Player1"
	C= None
	TimeWeaponStarted= None
	R= None
	Rn= None
	w= None
	RSQdist=None
	WeaponActive= 0
	grasped= 0
	tFinished= None
	Weapon= None
	ThrownBy=None
	Target= None
	Time2Grasp=0.4 
	spinsound=None
	
	def __init__ (self, me):
		ItemTypes.PersistantItemType.__init__(self, me)
		me.Weapon= 1
		self.Name= me.Name
		self.Speed= 15000.0
		self.Spin= -0.8
		self.Axis= (1.0, 0.0, 0.0)
		self.OwnerName= "Player1"
		self.C= None
		self.TimeWeaponStarted= None
		self.R= None
		self.Rn= None
		self.w= None
		self.RSQdist=None
		self.WeaponActive= 0
		self.grasped= 0
		self.tFinished= None
		self.Weapon= None
		self.ThrownBy=None
		self.Target= None
		self.Time2Grasp=0.4
		# Create a looped sound
		SoundName= "..\\..\\Sounds\\vueltas-en-el-aire.wav"
		self.spinsound= Bladex.CreateEntity (me.Name+"LoopSound", "Entity Sound", 0, 0, 0)
		self.spinsound.SetSound (SoundName)
		self.spinsound.MinDistance=5000
		self.spinsound.MaxDistance=30000
		me.Link(self.spinsound)
		
		
	def __getstate__(self):
		state= ItemTypes.PersistantItemType.__getstate__(self)
		ThrownByName=""
		WeaponName=""
		SpinSoundName=""
		if self.Weapon: WeaponName=self.Weapon.Name
		if self.ThrownBy: ThrownByName=self.ThrownBy.Name
		if self.spinsound: SpinSoundName=self.spinsound.Name
		
		state[1]["BoomerangWeapon"]=(self.Name,
								self.Speed,
								self.Spin,
								self.Axis,
								self.OwnerName,
								self.C,
								self.TimeWeaponStarted,
								self.R,
								self.Rn,
								self.w,
								self.RSQdist,
								self.WeaponActive,
								self.grasped,
								self.tFinished,
								WeaponName,
								ThrownByName,
								self.Target,
								self.Time2Grasp,
								SpinSoundName)
								
		
		return state
	
	def __setstate__(self,parm):
		ItemTypes.PersistantItemType.__setstate__(self,parm)
		if parm[0]==1:
			parms=parm[1]["BoomerangWeapon"]
			ThrownByName=""
			WeaponName=""
			SpinSoundName=""
			
			(self.Name,
			self.Speed,
			self.Spin,
			self.Axis,
			self.OwnerName,
			self.C,
			self.TimeWeaponStarted,
			self.R,
			self.Rn,
			self.w,
			self.RSQdist,
			self.WeaponActive,
			self.grasped,
			self.tFinished,
			WeaponName,
			ThrownByName,
			self.Target,
			self.Time2Grasp,
			SpinSoundName)= parms
			
			if WeaponName: self.Weapon=Bladex.GetEntity(WeaponName)
			if ThrownByName: self.ThrownBy=Bladex.GetEntity(ThrownByName)
			if SpinSoundName: self.spinsound=Bladex.GetEntity(SpinSoundName)
			
		else:
			self.Name="Unnamed"


	
	def ThrowReleaseEventHandler (self,EntityName,EventName):
		
		weapon= Bladex.GetEntity(self.Name)
		if not weapon:
			return
		self.OwnerName= weapon.Parent
		if not self.OwnerName:
			return
		owner=Bladex.GetEntity(self.OwnerName)
		if not owner or owner.InvRight != self.Name:
			return

		if owner.ActiveEnemy:
			enemy = Bladex.GetEntity(owner.ActiveEnemy)
			if enemy and enemy.Person:
				TargetPos= enemy.GraspPos ("ViewPoint")
		else:
			TargetPos= owner.Rel2AbsPoint(0,-10000.0,0.0)
	
		if weapon.TestHit:
			return

		Actions.RemoveFromInventory (owner, weapon, EventName)
		
		SourcePos= weapon.Position
		
		offsetx,offsety,offsetz= B3DLib.Scale(B3DLib.Normalize((TargetPos[0]-SourcePos[0], TargetPos[1]-SourcePos[1], TargetPos[2]-SourcePos[2])), 1000.0)
		TargetPos= TargetPos[0]+offsetx, TargetPos[1]+offsety, TargetPos[2]+offsetz

		self.C= (SourcePos[0]+TargetPos[0])*0.5, (SourcePos[1]+TargetPos[1])*0.5, (SourcePos[2]+TargetPos[2])*0.5
		self.TimeWeaponStarted= Bladex.GetTime()
		self.R= SourcePos[0]-self.C[0], SourcePos[1]-self.C[1], SourcePos[2]-self.C[2]
		self.RSQdist= abs(self.R[0]**2.0+self.R[1]**2.0+self.R[2]**2.0)
		moduloR= math.sqrt(self.RSQdist)
		scale= (moduloR/8.0) / math.sqrt(self.R[2]*self.R[2]+self.R[0]*self.R[0])
		self.Rn= -self.R[2]*scale, 0.0, self.R[0]*scale
		self.w = self.Speed / moduloR
		Bladex.SetAfterFrameFunc("DalWeaponMoveWeapon", self.MoveWeapon)
		self.WeaponActive= 0
		self.grasped= 0
		self.tFinished= Actions.TWOPI/self.w
		self.Weapon= weapon
		self.ThrownBy= owner  # this pointer may not be valid
		self.Time2Grasp= Bladex.GetAnimationDuration("Kgt_tke_r_02")*0.2
		self.spinsound.PlaySound(-1)
		weapon.MessageEvent(Reference.MESSAGE_STOP_WEAPON,0,0)
		InitDataField.Initialise(weapon)
		
	def MoveWeapon (self, time):
		self.Weapon.RemoveFromWorld()
		t= time-self.TimeWeaponStarted
		wt= self.w*t
		cos_wt= math.cos(wt)
		sin_wt= math.sin(wt)
		P= self.R[0]*cos_wt + self.Rn[0]*sin_wt, self.R[1]*cos_wt + self.Rn[1]*sin_wt, self.R[2]*cos_wt + self.Rn[2]*sin_wt
		self.Weapon.Position= P[0]+self.C[0], P[1]+self.C[1], P[2]+self.C[2]
		
		if wt>=Actions.TWOPI:
			owner=Bladex.GetEntity(self.OwnerName)
			if owner:
				inv= owner.GetInventory()
				inv.AddWeapon(self.Weapon.Name)
				if not owner.InvRight:
					inv.LinkRightHand(self.Weapon.Name)
			Bladex.RemoveAfterFrameFunc("DalWeaponMoveWeapon")
		elif wt >= Actions.PI*1.5:
			if self.WeaponActive:
				self.Weapon.MessageEvent(Reference.MESSAGE_STOP_WEAPON,0,0)
				self.Weapon.MessageEvent(Reference.MESSAGE_STOP_TRAIL,0,0)
				self.WeaponActive= 0
		elif wt >= Actions.PI and self.WeaponActive:
			owner=Bladex.GetEntity(self.OwnerName)
			if owner and owner.SQDistance2(self.Weapon) < self.RSQdist/2.0:
				self.Weapon.MessageEvent(Reference.MESSAGE_STOP_WEAPON,0,0)
				self.Weapon.MessageEvent(Reference.MESSAGE_STOP_TRAIL,0,0)
				self.WeaponActive= 0
		elif wt >= Actions.PI*0.5:
			if not self.WeaponActive:
				self.Weapon.MessageEvent(Reference.MESSAGE_START_WEAPON,0,0)
				self.Weapon.MessageEvent(Reference.MESSAGE_START_TRAIL,0,0)
				self.WeaponActive= 1
		
		if (not self.grasped) and t+self.Time2Grasp >= self.tFinished:
			self.grasped=1
			self.spinsound.StopSound()
			owner=Bladex.GetEntity(self.OwnerName)
			if owner and owner.Life>0:
				owner.Wuea=Reference.WUEA_ENDED
				owner.InterruptCombat()
				owner.LaunchAnmType("tke_r_02")
				#owner.LaunchAnmType("catch") The catch animation is too slow for Player chars
			else:
				self.Weapon.MessageEvent(Reference.MESSAGE_STOP_WEAPON,0,0)
				self.Weapon.MessageEvent(Reference.MESSAGE_STOP_TRAIL,0,0)
				self.WeaponActive= 0
				self.Weapon.Impulse(0,10,0)
				Bladex.RemoveAfterFrameFunc("DalWeaponMoveWeapon")
		# Angular velocity
		self.Weapon.RotateRel(0.0, 0.0, 0.0 ,self.Axis[0],self.Axis[1],self.Axis[2],self.Spin,1)
		
		
		
		
		
class DalWeapon(BoomerangWeapon):
	def __init__ (self, me):
		BoomerangWeapon.__init__(self, me)
		GenFX.AddWeaponFX(me.Name, self)



class XtraWeaponFX:

	def __init__(self, WeaponName, auraparams, auragradient, prtldata, lightdata):
		self.ObjId= ObjStore.GetNewId()
		ObjStore.ObjectsStore[self.ObjId]= self
		weapon=Bladex.GetEntity(WeaponName)
		self.WeaponName=WeaponName
		self.Aura=None
		self.Particles=None
		self.Light=None
		if auraparams:
			s, a, ci, f, b, am=auraparams
			m, r1, g1, b1, a1, imd, r2, g2, b2, a2, emd=auragradient
			self.Aura=Bladex.CreateEntity(WeaponName+"Aura", "Entity Aura", 0, 0, 0)
			self.Aura.SetAuraParams(s, a, ci, f, b, am)
			self.Aura.SetAuraGradient(m, r1, g1, b1, a1, imd, r2, g2, b2, a2, emd)
			weapon.Link(self.Aura)
			self.Aura.SetAuraActive(1)
		if prtldata:
			pt, pps, v, nv, rv, g, fr, ff, t2l=prtldata
			self.Particles=Bladex.CreateEntity(WeaponName+"Particles", "Entity Particle System Dobj", 0, 0, 0)
			self.Particles.ObjectName=WeaponName
			self.Particles.ParticleType=pt
			self.Particles.PPS=pps
			self.Particles.Velocity=v
			self.Particles.NormalVelocity=nv
			self.Particles.RandomVelocity=rv
			self.Particles.YGravity=g
			self.Particles.Friction=fr
			self.Particles.FollowFactor=ff
			self.Particles.Time2Live=t2l
		if lightdata:
			i, color, fl=lightdata
			self.Light=Bladex.CreateEntity(WeaponName+"Light", "Entity Spot", 0, 0, 0)
			self.Light.Intensity=i
			self.Light.Color=color
			self.Light.Flick=fl
			self.Light.CastShadows=0
			self.Light.Visible=0
			weapon.Link(self.Light)

	def persistent_id(self):
		return self.ObjId

	def __getstate__(self):
		return (1,
				self.ObjId,
				self.WeaponName,
				GameStateAux.SaveEntityAux(self.Aura),
				GameStateAux.SaveEntityAux(self.Particles),
				GameStateAux.SaveEntityAux(self.Light)
			)


	def __setstate__(self,parm):
		#print "GenFX.__setstate__()",parm
		if parm[0]==1:
			self.ObjId= parm[1]
			ObjStore.ObjectsStore[self.ObjId]=self
			self.WeaponName=parm[2]
			self.Aura=GameStateAux.LoadEntityAux(parm[3])
			self.Particles=GameStateAux.LoadEntityAux(parm[4])
			self.Light=GameStateAux.LoadEntityAux(parm[5])
		else:
			print "XtraWeaponFX.__setstate__() -> Version mismatch"
			self.WeaponName=""
			self.Aura=""
			self.Particles=""
			self.Light=""
			self.ObjId= ObjStore.GetNewId()
			ObjStore.ObjectsStore[self.ObjId]=self




def AddXtraWeaponFX(WeaponName,data):
	weapon=Bladex.GetEntity(WeaponName)
	if not data:
		InitDataField.Initialise(weapon)
		data= weapon.Data
	if weapon.Kind in ("VampWeapon2","VampWeapon3","VampWeapon4"):
		auraparams=(80, 1, 1, 0, 0, 0)
		auragradient=(2, 0.8, 0.1, 0.1, 0.2, 0.0, 0.4, 0.0, 0.0, 0.0, 0.6)
		prtldata=("GotasSangre", 20, (0.0, 0.0, 0.0), 0.0, 0.0, 2000.0, 0.01, 0.0, 24) # (PrtlType, PPS, Vel=(v1, v2, v3), NormalVel, RndVel, YGrav, Friction, FollowFactor, Time2Live)
		lightdata=()
		#weapon.SelfIlum=0.3
		#weapon.Alpha=0.99
		#weapon.RasterMode="AdditiveAlpha"
	elif weapon.Kind == "Varita7":
		auraparams=(80, 1, 1, 0, 0, 0)
		auragradient=(2, 0.5, 0.6, 0.0, 0.2, 0.0, 0.2, 0.3, 0.0, 0.1, 0.5)
		prtldata=("GasVenenoso", 30, (0.0, 0.0, 0.0), 0.0, 1.0, 0.0, 0.02, 0.0, 60)
		lightdata=()

	else:
		print "No hay efecto definido para este tipo de arma!"
		return
	data.XtraWeaponFX=XtraWeaponFX(WeaponName, auraparams, auragradient, prtldata, lightdata)
	
	
class WierdWeapons:
	def __init__ (self, me):
		AddXtraWeaponFX(me.Name, self)








class BreakSector:
	def __init__(self):
		self.ObjId=ObjStore.GetNewId() # Para identificarlo al grabar/guardar
		ObjStore.ObjectsStore[self.ObjId]=self
		self.sector=None
		self.sector2=None
		self.break_sound=None
		self.hit_sound=None
		self.polvo = 0
		self.polvo_vel=None
		self.polvo_p0=None
		self.polvo_p1=None
		self.polvo_p2=None
		self.polvo_p3=None
		self.life=None
		self.pos = (0,0,0)
		self.normal = (1,0,0)

	def persistent_id(self):
		return self.ObjId

	def __getstate__(self):
		return (1,
				self.ObjId,
				self.sector,
				self.sector2,
				self.break_sound,
				self.hit_sound,
				self.polvo,
				self.polvo_vel,
				self.polvo_p0,
				self.polvo_p1,
				self.polvo_p2,
				self.polvo_p3,
				self.life,
                self.pos,
                self.normal
				)

	def __setstate__(self,parm):
		if parm[0]==1:
			self.ObjId=parm[1]
			ObjStore.ObjectsStore[self.ObjId]=self
			self.sector=parm[2]
			self.sector2=parm[3]
			self.break_sound=parm[4]
			self.hit_sound=parm[5]
			self.polvo=parm[6]
			self.polvo_vel=parm[7]
			self.polvo_p0=parm[8]
			self.polvo_p1=parm[9]
			self.polvo_p2=parm[10]
			self.polvo_p3=parm[11]
			self.life=parm[12]
			self.pos=parm[13]
			self.normal=parm[14]
		else:
			print "Version mismatch in BreakSector"
			self.ObjId=ObjStore.GetNewId() # Para identificarlo al grabar/guardar
			ObjStore.ObjectsStore[self.ObjId]=self
			self.sector=None
			self.sector2=None
			self.break_sound=None
			self.hit_sound=None
			self.polvo = 0
			self.polvo_vel=None
			self.polvo_p0=None
			self.polvo_p1=None
			self.polvo_p2=None
			self.polvo_p3=None
			self.life=None
			self.pos = (0,0,0)
			self.normal = (1,0,0)

	def HitSector(self,sector,weapon,ipx,ipy,ipz,ximpulse=0,yimpulse=0,zimpulse=0,x_norm=0,y_norm=0,z_norm=0,material=""):
		self.life = self.life - 1

		if self.life <= 0:
			self.sector.DoBreak(self.normal, (ipx,ipy,ipz), (0.0, 0.0, 0.0))
			self.sector.Active = 1
			self.sector2.OnHit = ""
			self.break_sound.Play(self.pos[0],self.pos[1],self.pos[2],0)		

			if self.polvo:
				self.SetPolvo()
		else:
			self.hit_sound.Play(ipx,ipy,ipz,0)

	def InitBreak(self,pos,pos2,normal,life,dir,dir1,dir2):
		self.sector2 = Bladex.GetSector(pos2[0],pos2[1],pos2[2])
		self.sector = Bladex.GetSector(pos[0],pos[1],pos[2])
		
		self.break_sound=Bladex.CreateSound('..\..\Sounds\\madera-rotura-pesada.wav', 'SonidoDesprendimiento')
		self.break_sound.Volume=1.0
		self.break_sound.MinDistance=3000
		self.break_sound.MaxDistance=40000

		self.hit_sound=Bladex.CreateSound('..\..\Sounds\\golpe-madera-pesada.wav', 'SonidoHit')
		self.hit_sound.Volume=1.0
		self.hit_sound.MinDistance=3000
		self.hit_sound.MaxDistance=40000

		self.sector.InitBreak(dir, dir1, dir2)
		self.sector2.OnHit = self.HitSector		
		self.sector2.ActiveSurface = normal
		self.normal = normal[0] * -6.5,normal[1] * -6.5,normal[2] * -6.5

		self.sector.Active = 0
		self.life = life
		self.pos = pos

	def ActivatePolvo(self,p1,p2,p3,p4,vel):
		self.polvo_vel = vel
		self.polvo_p0 = p1
		self.polvo_p1 = p2
		self.polvo_p2 = p3
		self.polvo_p3 = p4
		self.polvo = 1

	def SetPolvo(self):
		self.polvoTri(self.polvo_p0,self.polvo_p1,self.polvo_p2,self.polvo_vel,"dustA")
		self.polvoTri(self.polvo_p1,self.polvo_p2,self.polvo_p3,self.polvo_vel,"dustB")

	def polvoTri(self,a,b,c,vel,name):
		dust=Bladex.CreateEntity(name, "Entity Particle System D3", a[0],a[1],a[2])
		dust.D1= b[0]-a[0] ,b[1]-a[1] ,b[2]-a[2]
		dust.D2= c[0]-b[0] ,c[1]-b[1] ,c[2]-b[2]
		dust.ParticleType="MediumDust"
		dust.YGravity=230.0
		dust.Friction=0.2
		dust.PPS=1000
		dust.Velocity= vel
		dust.RandomVelocity=20.0
		dust.Time2Live=16
		dust.DeathTime=Bladex.GetTime() + 0.8
		
		
		
		
		
		


####################################################################################################################


class AmuletoInvincibility (ItemTypes.ItemOfProtection):
        def __init__ (self, me):
                ItemTypes.ItemOfProtection.__init__(self, me)
                self.UsedBy= "Player1"
                self.UseTime= 60.0
                self.Resistances= {}
                self.nUses= 2

        def UseStart (self, ObjectName, use_from):
                ItemTypes.ItemOfProtection.UseStart (self, ObjectName, use_from)
                pj=Bladex.GetEntity('Player1')
                pj.Data.Invincibility= 1
                GenFX.AddPersonItemFX(self.UsedBy, ObjectName, self.UseTime)
		    
        def UseEnd (self,ObjectName, UserName):
                pj=Bladex.GetEntity('Player1')
                pj.Data.Invincibility= 0
                ItemTypes.ItemOfProtection.UseEnd (self, ObjectName, UserName)




####################################################################################################################


class BossAsleep(Enm_Def.NPCPerson):

	Durmiendo=0
	Murmurando=0
	Molestado=0
	Muerto=0
	ronquidos=None
	habladormido=None
	molestia=None
	muerte=None

	def __init__(self, person):
		Enm_Def.NPCPerson.__init__(self, person)
		self.Durmiendo=0
		self.Murmurando=0
		self.Molestado=0
		self.Muerto=0
		person.SetTmpAnmFlags(1, 1, 0, 0, 1, 1, 0)
		person.LaunchAnimation("Tkn_sleep2")
		person.SetOnFloor()

		self.ronquidos=Bladex.CreateSound("..\\..\\Sounds\\snore-loop.wav", "Ronquidos")
		self.ronquidos.Volume=1
		self.ronquidos.Scale=1.0
		self.ronquidos.MinDistance= 5000
		self.ronquidos.MaxDistance=15000

		self.habladormido=Bladex.CreateSound("..\\..\\Sounds\\drunk-loop.wav", "HablaDormido")
		self.habladormido.Volume=1
		self.habladormido.Scale=1.0
		self.habladormido.MinDistance= 5000
		self.habladormido.MaxDistance=50000

		self.molestia=Bladex.CreateSound("..\\..\\Sounds\\drunk-loop-short.wav", "Molestia")
		self.molestia.Volume=1
		self.molestia.Scale=1.0
		self.molestia.MinDistance= 5000
		self.molestia.MaxDistance=25000

		self.muerte=Bladex.CreateSound("..\\..\\Sounds\\knight-die.wav", "Muerte")
		self.muerte.Volume=1
		self.muerte.Scale=1.0
		self.muerte.MinDistance= 5000
		self.muerte.MaxDistance=15000


	def Murmura(self, entity_name):
		self.Murmurando=1
		if self.Durmiendo:
			self.Durmiendo=0
			self.ronquidos.Stop()
		if self.Molestado:
			self.Molestado=0
			self.molestia.Stop()
		person=Bladex.GetEntity(entity_name)
		person.Wuea=Reference.WUEA_ENDED
		person.LaunchAnimation("Tkn_sleep")
		person.SetOnFloor()
		self.habladormido.Play(person.Position[0], person.Position[1], person.Position[2], 0)
		person.AnmEndedFunc=self.Duerme
	
	
	def Duerme(self, entity_name):
		if self.Muerto:
			return
		self.Durmiendo=1
		if self.Murmurando:
			self.Murmurando=0
		if self.Molestado:
			self.Molestado=0
		person=Bladex.GetEntity(entity_name)
		person.Wuea=Reference.WUEA_ENDED
		person.SetTmpAnmFlags(1, 1, 0, 0, 1, 1, 0)
		person.LaunchAnimation("Tkn_sleep2")
		person.SetOnFloor()
		self.ronquidos.Play(person.Position[0], person.Position[1], person.Position[2], -1)


	def Molestia(self, entity_name):
		self.Molestado=1
		if self.Durmiendo:
			self.Durmiendo=0
			self.ronquidos.Stop()
		if self.Murmurando:
			self.Murmurando=0
			self.habladormido.Stop()
		person=Bladex.GetEntity(entity_name)
		person.Wuea=Reference.WUEA_ENDED
		person.LaunchAnimation("Tkn_sleep_hit")
		person.SetOnFloor()
		self.molestia.Play(person.Position[0], person.Position[1], person.Position[2], 0)
		person.AnmEndedFunc=self.Duerme


	def Muere(self, entity_name):
		if self.Durmiendo:
			self.Durmiendo=0
			self.ronquidos.Stop()
		if self.Murmurando:
			self.Murmurando=0
			self.habladormido.Stop()
		if self.Molestado:
			self.Molestado=0
			self.molestia.Stop()
		person=Bladex.GetEntity(entity_name)
		person.Wuea=Reference.WUEA_ENDED
		person.LaunchAnimation("Tkn_dth_sleep")
		person.SetOnFloor()
		self.muerte.Play(person.Position[0], person.Position[1], person.Position[2], 0)
		self.Muerto=1

	# Functions for loading and saving state
	def __getstate__(self):
		NPCPerson_state=Enm_Def.NPCPerson.__getstate__(self)
		if(NPCPerson_state[0]!=1):
			#print "ERROR: BossAsleep.__getstate__(): Base class version differs."
			return NPCPerson_state
		NPCPerson_state[1]["BossAsleep"]=(self.ronquidos.Name,self.habladormido.Name,
										   self.molestia.Name,self.muerte.Name,
										   self.Durmiendo,self.Murmurando,self.Molestado,self.Muerto
										  )
		return NPCPerson_state
	
	def __setstate__(self,parm):
		Enm_Def.NPCPerson.__setstate__(self,parm)
		version=parm[0]
		if version==1:
			parms=parm[1]["BossAsleep"]
			self.ronquidos=Bladex.GetSound(parms[0])
			self.habladormido=Bladex.GetSound(parms[1])
			self.molestia=Bladex.GetSound(parms[2])
			self.muerte=Bladex.GetSound(parms[3])
			self.Durmiendo=parms[4]
			self.Murmurando=parms[5]
			self.Molestado=parms[6]
			self.Muerto=parms[7]

#######################################################################################################################
###########################################bombs#######################################################################


class ActiveProjectile(ItemTypes.PersistantItemType):
	def __init__(self, me):
		ItemTypes.PersistantItemType.__init__(self, me)
		me.Weapon= 1
		self.Age= 0
		self.FadeTime= 1.0
		self.Speed= 10000.0
		self.missileName= ""
		self.LastHitTime=-1
		self.AuxFuncsData=None
		self.OwnerName= ""
		self.PtrlType=""
		self.SpecialExtraDamage= []
		self.Name= me.Name
		
		
		
		
		self.WhileSound=Bladex.CreateEntity (me.Name+"MissileLoopSound", "Entity Sound", 0, 0, 0)
		self.ImpactSound=Bladex.CreateEntity (me.Name+"MissileImpactSound", "Entity Sound", 0, 0, 0)
		if me.Kind=="Canica":
			self.WhileSound.SetSound("..\\..\\Sounds\\energy-ball.wav")
			self.ImpactSound.SetSound("..\\..\\Sounds\\energy-ball-impact.wav")
			self.PtrlType="LargeFire"
			self.SpecialExtraDamage= [["Fire", +1000.0],]
		elif me.Kind=="Suriken":
			self.WhileSound.SetSound("..\\..\\Sounds\\vueltas-en-el-aire.wav")
			self.ImpactSound.SetSound("..\\..\\Sounds\\slice-splat1.wav")
			self.PtrlType="GasVenenoso"
			self.SpecialExtraDamage= [["Venom",+50.0],]
		elif me.Kind=="Phurbhu":
			self.WhileSound.SetSound("..\\..\\Sounds\\electric-eels.wav")
			self.ImpactSound.SetSound("..\\..\\Sounds\\golpe_hueso_1.wav")
			self.PtrlType="SnowDust"
			self.SpecialExtraDamage= [["Ice", +1000.0],]
		self.ImpactSound.MinDistance=5000
		self.ImpactSound.MaxDistance=30000
		self.WhileSound.MinDistance=5000
		self.WhileSound.MaxDistance=30000
		me.Link(self.WhileSound)

		
	def __getstate__(self):
		state= ItemTypes.PersistantItemType.__getstate__(self)
		state[1]["ActiveProjectile"]=   (self.Age,
						 self.FadeTime,
						 self.Speed,
						 self.missileName,
						 self.LastHitTime,
						 self.WhileSound.Name,
						 self.ImpactSound.Name,
						 self.AuxFuncsData,
						 self.OwnerName,
						 self.PtrlType,
						 self.SpecialExtraDamage,
						 self.Name)
		return state
		
		
	def __setstate__(self,parm):
		ItemTypes.PersistantItemType.__setstate__(self,parm)
		if parm[0]==1:
			parms=parm[1]["ActiveProjectile"]
			self.Age=parms[0]
			self.FadeTime= parms[1]
			self.Speed=parms[2]
			self.missileName= parms[3]
			self.LastHitTime= parms[4]
			self.WhileSound= Bladex.GetEntity(parms[5])
			self.ImpactSound= Bladex.GetEntity(parms[6])
			self.AuxFuncsData= parms[7]
			self.OwnerName=  parms[8]
			self.PtrlType= parms[9]
			self.SpecialExtraDamage= parms[10]
			self.Name=parms[11]
		else:
			self.Age=0
			self.FadeTime= 1.0
			self.Speed= 10000.0
			self.missileName= ""
			self.LastHitTime=-1
			self.WhileSound= Bladex.GetEntity(self.Name+"MissileLoopSound")
			self.ImpactSound= Bladex.GetEntity(self.Name+"MissileImpactSound")
			self.AuxFuncsData= None
			self.OwnerName= "Player1"
			self.PtrlType= ""
			self.SpecialExtraDamage= []
			self.Name=""
			
			
		
		weapon=  Bladex.GetEntity(self.Name)		
		if self.missileName:
			missile= Bladex.GetEntity(self.missileName)
			if missile:
				missile.InflictHitFunc= self.BladeSwordInflictHitFunc
				missile.OnHitFunc= self.MissileOnHitFunc
				if weapon:
					weapon.InflictHitFunc= self.BladeSwordInflictHitFunc
			else:
				print "Missile "+self.missileName+" unavailable for linking...."

	
	def DropReleaseEventHandler (self,EntityName,EventName):
		weapon= Bladex.GetEntity(self.Name)
		if not weapon:
			return
		self.OwnerName= weapon.Parent
		if not self.OwnerName:
			return		
		owner=Bladex.GetEntity(self.OwnerName)
		if not owner or owner.InvRight != self.Name:
			return	
		if weapon.TestHit:
			return
		Actions.RemoveFromInventory (owner, weapon, EventName)
		ix, iy, iz = owner.Rel2AbsVector(-1000.0, -1500.0, 0.0)
		weapon.Impulse(ix, iy, iz)
		weapon.ExcludeHitFor(owner)
		owner.DelAnmEventFunc(EventName)
		Reference.EntitiesObjectData[weapon.Name]= [Reference.OBJ_ITEM]
		weapon.Data=Projectile(weapon)

	
	def ThrowReleaseEventHandler (self,EntityName,EventName):
		print "Throwing...."
		weapon= Bladex.GetEntity(self.Name)
		if not weapon:
			return
		self.OwnerName= weapon.Parent
		if not self.OwnerName:
			return
		owner=Bladex.GetEntity(self.OwnerName)
		if not owner or owner.InvRight != self.Name:
			return
		if weapon.TestHit:
			return
		print "Bomb released"
			
		Actions.RemoveFromInventory (owner, weapon, EventName)
		# Create a magic missile
		self.Age= self.Age+1
		x,y,z= weapon.Position
		missile= Bladex.CreateEntity(self.Name+"_Missile_"+`self.Age`, "Entity Magic Missile", x,y,z)
		InitDataField.Initialise(missile)
		missile.CastShadows=0
		missile.Color=0, 0, 0
		#missile.Visible=0
		self.missileName= missile.Name
		
		# Set the velocity of the missile
		if owner.ActiveEnemy:
			enemy= Bladex.GetEntity(owner.ActiveEnemy)
			if enemy and enemy.Person:
				tx1,ty1,tz1= enemy.GraspPos ("ViewPoint")
				tx2,ty2,tz2= enemy.Position
				tx= (tx1+tx2)/2.0; ty= (ty1+ty2)/2.0; tz= (tz1+tz2)/2.0; 
			else:
				tx,ty,tz= owner.Rel2AbsPoint(0,-30000.0,0.0)
		else:
			tx,ty,tz= owner.Rel2AbsPoint(0,-30000.0,0.0)
		
		angley= -B3DLib.GetYAngle(tx-x,ty-y,tz-z)
		vx,vy,vz= owner.Rel2AbsVector(0.0, -math.cos(angley)*self.Speed, -math.sin(angley)*self.Speed)
		
		anglexz= B3DLib.Pos2PosXZAngle(x,y,z,tx,ty,tz)
		diff_angle= min (max (B3DLib.DiffAngle(anglexz, owner.Angle), -Actions.FACINGANGLE), Actions.FACINGANGLE)
		cos_ang= math.cos(diff_angle); sin_ang= math.sin(diff_angle)
		vx,vy,vz=  (vx*cos_ang-vz*sin_ang, vy, vx*sin_ang+vz*cos_ang)
		
		# Reorient and Link the sword to the missile
		weapon.Orientation=0.707107,0.707107,0.000000,0.000000
		weapon.RotateRel(0,0,0, 0,-1,0, 3.14159/2.0)
		weapon.RotateRel(0,0,0, -1,0,0, (3.0*3.14159/2.0)-anglexz)
		weapon.RotateRel(0,0,0, 0,-1,0, -angley)
		
		weapon.Position=0, 0, 0
		missile.Link(weapon)
		AuxFuncs.FadeObject(weapon.Name, weapon.Alpha, 0.01, self.FadeTime)
		AuxFuncs.ColorObject(missile.Name, missile.Color, (190,90,90), self.FadeTime*2.0)
		missile.Velocity= vx,vy,vz
		
		prtl=Bladex.CreateEntity(weapon.Name+"TrailParticles"+`self.Age`, "Entity Particle System Dobj", 0, 0, 0)
		prtl.ObjectName=weapon.Name
		prtl.ParticleType=self.PtrlType
		prtl.PPS=400
		prtl.Velocity=0.0, 0.0, 0.0
		prtl.NormalVelocity=14.0
		prtl.RandomVelocity=4.0
		prtl.YGravity=0.0
		prtl.Friction=0.01
		prtl.FollowFactor=0.0
		prtl.Time2Live=30
		self.WhileSound.PlaySound(-1)
		
		Reference.EntitiesObjectData[missile.Name]= Reference.DefaultObjectData[weapon.Kind]
		for damage in self.SpecialExtraDamage:
			Reference.EntitiesObjectData[missile.Name].append (damage)
		missile.OnHitFunc= self.MissileOnHitFunc
		missile.Data.ThrownBy= owner  		# this pointer may not be valid
		missile.InflictHitFunc= self.BladeSwordInflictHitFunc
		weapon.InflictHitFunc= self.BladeSwordInflictHitFunc
		
		
	def BladeSwordInflictHitFunc(self, EntityName, VictimName, ImpX, ImpY, ImpZ):
		if self.missileName:
			self.MissileOnHitFunc (self.missileName, VictimName)
	
	
	def DeleteMissileData(self):
		if self.missileName and Reference.EntitiesObjectData.has_key(self.missileName):
			del Reference.EntitiesObjectData[self.missileName]
			self.missileName= ""
			
			
	def MissileOnHitFunc (self, EntityName, hit_entity):
		time=Bladex.GetTime()
		if time==self.LastHitTime:
			return
		if hit_entity:
			print EntityName+" hitting "+hit_entity
			pass
		else:
			print EntityName+" hitting world"
			pass
			
		missile= Bladex.GetEntity(EntityName)
		weapon= Bladex.GetEntity(self.Name)
		if weapon: 
			weapon.Data.InflictHitFunc=0
		if missile and weapon:
			Bladex.AddScheduledFunc(time, self.DeleteMissileData, (), "DeleteMissileData")
			prtl=Bladex.GetEntity(weapon.Name+"TrailParticles"+`self.Age`)
			if prtl:
				prtl.DeathTime=Bladex.GetTime()
			missile.Unlink(weapon)
			missile.Stop()
			missile.SubscribeToList("Pin")
			weapon.RemoveFromWorld()
			self.WhileSound.StopSound()
			self.ImpactSound.Position=weapon.Position
			self.ImpactSound.PlaySound(0)
			
			

					
					
					
class Projectile (ItemTypes.PersistantItemType):

	def __init__(self, me):
		ItemTypes.PersistantItemType.__init__(self, me)
		me.Weapon= 1
		self.Name= me.Name
		self.Age = 0
		self.OwnerName=""
		
		Reference.EntitiesObjectData[self.Name]= [Reference.OBJ_ITEM]
		weapon= Bladex.GetEntity(self.Name)
		InitDataField.Initialise(weapon)		
		me.UseFunc = self.UseProjectile

	def __getstate__(self):
		state= ItemTypes.PersistantItemType.__getstate__(self)
		state[1]["Projectile"]=   (self.Name,self.OwnerName)
		return state
		
		
	def __setstate__(self,parm):
		ItemTypes.PersistantItemType.__setstate__(self,parm)
		if parm[0]==1:
			parms=parm[1]["Projectile"]
			self.Name=parms[0]
			self.OwnerName=  parms[1]		
		else:
			self.Name=""
			self.OwnerName=""
		

	def UseProjectile(self, BombName, TipoUso):
		bomb=Bladex.GetEntity(BombName)
		if TipoUso == Actions.USE_FROM_INV:
		   	ownerName= bomb.Data.UsedBy
		   	Actions.FreeBothHands(ownerName)
		   	owner=Bladex.GetEntity(ownerName)
		   	if owner and owner.Life >0:
		   		owner.Data.throw_weapon = None
      	              	inv=owner.GetInventory()
      	              	inv.RemoveObject(BombName)
   	              	Change.ChangeObject(ownerName, BombName, self.FinishChange)
   	        elif TipoUso == Actions.USE_FROM_TAKE:
		   	Actions.StdUse (ownerName)


	def FinishChange(self, EntityName,ObjectName):
		bomb=Bladex.GetEntity(ObjectName)
		Reference.EntitiesObjectData[ObjectName]= [Reference.OBJ_STANDARD,20, 0, 1.0, Reference.THR_SPINNING, []]
	       	print "Player1 gotThrowing thing"
		bomb.Data=ActiveProjectile(bomb)   
  		print"bomb armed"


				
def CreateFireBomb (name,pos):
	fb=Bladex.CreateEntity(name,"Canica",pos[0],pos[1],pos[2], "Weapon")
	fb.Scale=1.0
	fb.Impulse(0,0,0)
	fb.Data=Projectile(fb)
	return fb.Data
			
					
def CreateCyanideStar (name,pos):
	cs=Bladex.CreateEntity(name,"Suriken",pos[0],pos[1],pos[2], "Weapon")
	cs.Scale=1.0
	cs.Impulse(0,0,0)
	cs.Data=Projectile(cs)
	return cs.Data
							
							
def CreateIceRocket (name,pos,ori):
	ir=Bladex.CreateEntity(name,"Phurbhu",pos[0],pos[1],pos[2], "Weapon")
	ir.Scale=1.0
	ir.Orientation=ori
	ir.Impulse(0,0,0)
	ir.Data=Projectile(ir)
	return ir.Data		
					
					



# The blade glows blue when Orks are near.........

class KingSword(ItemTypes.ActivateableSpecialWeapon):

	PeriodicCheckTime= 0

	def __init__(self, me):
		ItemTypes.ActivateableSpecialWeapon.__init__(self, me)
		me.Weapon=1		
		self.PeriodicCheckTime= 8.0	
		self.ScanRange=25000
		self.Name= me.Name
		self.SpecialExtraDamage= [['Light',+500],]
		self.baddies=["Ork","Great_Ork"]
		self.Activate()
	
	def __getstate__(self):
		state= ItemTypes.ActivateableSpecialWeapon.__getstate__(self)
		state[1]["KingSword"]= (self.Name,
					self.PeriodicCheckTime,
					self.ScanRange,)
		return state



	def __setstate__(self,parm):
		ItemTypes.ActivateableSpecialWeapon.__setstate__(self,parm)
		if parm[0]==1:
			parms=parm[1]["KingSword"]
			self.Name=parms[0]
			self.PeriodicCheckTime=parms[1]
			self.ScanRange=parms[2]
		else:
			self.Name=""
			self.PeriodicCheckTime=8.0
			self.ScanRange=25000
			
		#self.Activate()			


	def Activate (self):
		Bladex.AddScheduledFunc(Bladex.GetTime()+self.PeriodicCheckTime, self.Scan, (self.Name,), self.Name+" Scan")
			

		
	def Scan (self, EntityName):
		me = Bladex.GetEntity(EntityName)
		
		if me:
			pos=me.Position
			possibleenemies=Bladex.GetEntitiesAt(pos[0],pos[1],pos[2],self.ScanRange)
			for id in possibleenemies:
				en=Bladex.GetEntity(id)
				if en:
					if en.Person:
						if en.Life>0 and en.Alpha >0.1:
							if en.Kind in ("Ork","Great_Ork"):
								aura = Auras.MakeAura(me.Name, self.PeriodicCheckTime-1,(25,1.0,1.0,1,0,0), (),(),(2,  0.8,0.8,1.0, 1.0, 0.6  , 0.0,0.0,1.0, 0.0, 1.0))
								
			Bladex.AddScheduledFunc(Bladex.GetTime()+self.PeriodicCheckTime, self.Scan, (self.Name,), self.Name+" Scan")

	
	
			
	
		
