import Bladex
from math import pow
import Reference
import EnemyTypes
import Sparks
import Actions
import pocimac
import ItemTypes
import darfuncs
import LevelFuncs
import Stars
import def_class
import math
import ExTypes
import Auras  #####
import QuiverTypes
import copy



global Live

Live=0



### Set these values to the expected player's level (0-19) at the beginning of the map
expected_player_lvl_min= 10
expected_player_lvl_max= 19

lvl_control=LevelFuncs.EnemyLevelControl (expected_player_lvl_min, expected_player_lvl_max)
### e.g. to give an enemy a level between 0 and 4, do
### pers.Level= lvl_control.GiveLevel(0, 4)

Bladex.AddCombustionDataFor("Lich", "Fire", 250, 400, 4, 1, 3, 144000) # se extingira en 40 horas!
Bladex.AddCombustionDataFor("Knight_Zombie", "Fire", 250, 400, 4, 1, 3, 144000) # se extingira en 40 horas!

#######################################################################################
#### Ork in backyard

pers=Bladex.CreateEntity("Lofty2","Great_Ork",-51000, -1000, 110750,"Person")
pers.Angle=0
pers.Level=10
o=Bladex.CreateEntity("Lofty2SH","Escudo2",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
Actions.TakeObject(pers.Name,"Lofty2SH")
o=Bladex.CreateEntity("Lofty2WP","Hacha3",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
Actions.TakeObject(pers.Name,"Lofty2WP")
EnemyTypes.EnemyDefaultFuncs(pers)
darfuncs.HideBadGuy(pers.Name)
pers.Data.OldImDeadFunc=pers.ImDeadFunc
pers.ImDeadFunc=Lofty2DED


###### Orks in Graveyard

pers=Bladex.CreateEntity("Sooty2","Ork",14350,-949,108810, "Person")
pers.Scale=1.0
pers.Angle=5.25
pers.Level=9
EnemyTypes.EnemyDefaultFuncs(pers)
o=Bladex.CreateEntity ("orkwp101", "Orksword", 0,0,0, "Weapon")
o.Scale=1.0
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name, "orkwp101")
o=Bladex.CreateEntity ("orksh101", "Escudo1", 0,0,0)
ItemTypes.ItemDefaultFuncs(o)
Sparks.MakeShield("orksh101")
Actions.TakeObject(pers.Name, "orksh101")
Actions.TakeObject(pers.Name, "keyg39")
pers.SetMesh("Dark_Ork")
darfuncs.HideBadGuy("Sooty2")
pers.Data.OldImDeadFunc=pers.ImDeadFunc
pers.ImDeadFunc=GrydOrkDED


pers=Bladex.CreateEntity("Sooty3","Ork",9000,-949.288824854,150000, "Person")
pers.Scale=1.0
pers.Angle=3
pers.Level=8
EnemyTypes.EnemyDefaultFuncs(pers)
#AniSound.AsignarSonidosOrcoOscuro("Sooty3")
o=Bladex.CreateEntity ("orkwp30", "HookSword", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name, "orkwp30")
o=Bladex.CreateEntity ("Pocima200_459", "Pocima200", 0,0,0)
o.Static=0
o.Solid=1
pocimac.CreatePotion("Pocima200_459")
Actions.TakeObject(pers.Name, "Pocima200_459")
pers.SetMesh("Dark_Ork")
darfuncs.HideBadGuy("Sooty3")
pers.Data.OldImDeadFunc=pers.ImDeadFunc
pers.ImDeadFunc=GrydOrkDED


pers=Bladex.CreateEntity("Sooty","Ork",-22850,-984,105250, "Person")
pers.Scale=1.0
pers.Angle=4.5
pers.Level=10
EnemyTypes.EnemyDefaultFuncs(pers)
o=Bladex.CreateEntity ("axe111", "Hacha5", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name, "axe111")
pers.SetMesh("Dark_Ork")
darfuncs.HideBadGuy("Sooty")


### Behind door

pers=Bladex.CreateEntity("Sooty5","Ork",-8480,-984.911536493,138630, "Person")
pers.Scale=1.0
pers.Angle=4.5
pers.Level=11
EnemyTypes.EnemyDefaultFuncs(pers)
o=Bladex.CreateEntity ("stick1", "Hacha", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject("Sooty5", "stick1")
pers.SetMesh("Dark_Ork")
darfuncs.HideBadGuy("Sooty5")
pers.Data.OldImDeadFunc=pers.ImDeadFunc
pers.ImDeadFunc=GrydOrkDED


#### Return to graveyard

pers=Bladex.CreateEntity("Sooty4","Ork",24137.648016,-984.911536493,146789.120729, "Person")
pers.Scale=1.0
pers.Angle=4.2679374269
pers.Level=15
EnemyTypes.EnemyDefaultFuncs(pers)
o=Bladex.CreateEntity ("Maza3_1100", "Maza3", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject("Sooty4", "Maza3_1100")
pers.SetMesh("Dark_Ork")
darfuncs.HideBadGuy("Sooty4")
pers.Data.OldImDeadFunc=pers.ImDeadFunc
pers.ImDeadFunc=GrydOrkDED


#### Shut in Shed

pers=Bladex.CreateEntity("Minot0","Minotaur",28800, -1118, -50000,"Person")
pers.Level=13
pers.Angle=0
o=Bladex.CreateEntity("Nobbler11","Mazapiedra",0,0,0,"Weapon")
Actions.TakeObject(pers.Name,"Nobbler11")
EnemyTypes.EnemyDefaultFuncs(pers)
pers.SetOnFloor()
darfuncs.HideBadGuy(pers.Name)


###### Demons in Tower

pers=Bladex.CreateEntity("Little_Demon_570","Little_Demon",40095.7819667,-9131.61599209,165500,"Person") 
pers.Level=8
pers.Angle=3.15
pers.Blind = 0
pers.Deaf = 0
EnemyTypes.EnemyDefaultFuncs(pers)
pers.SetOnFloor()
darfuncs.HideBadGuy(pers.Name)
pers.Data.OldImDeadFunc=pers.ImDeadFunc
pers.ImDeadFunc=Demon1Dead



pers=Bladex.CreateEntity("Little_Demon_5702","Little_Demon",33500,-9131,162000,"Person") 
pers.Level=9
pers.Angle=4
pers.Blind = 0
pers.Deaf = 0
EnemyTypes.EnemyDefaultFuncs(pers)
pers.SetOnFloor()
darfuncs.HideBadGuy(pers.Name)
pers.Data.OldImDeadFunc=pers.ImDeadFunc
pers.ImDeadFunc=Demon2Dead


pers=Bladex.CreateEntity("Little_Demon_5703","Little_Demon",46936,-9131,161700,"Person")  
pers.Level=10
pers.Angle=2.32 
pers.Blind = 0
pers.Deaf = 0
EnemyTypes.EnemyDefaultFuncs(pers)
pers.SetOnFloor()
darfuncs.HideBadGuy(pers.Name)
pers.Data.OldImDeadFunc=pers.ImDeadFunc
pers.ImDeadFunc=Demon3Dead


pers=Bladex.CreateEntity("Sarg2","Skeleton",39250, -5600, 156500,"Person")
pers.Angle=4
pers.Level=17
o=Bladex.CreateEntity("Sargwp112","FireSword",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
Actions.TakeObject(pers.Name,"Sargwp112")
o=Bladex.CreateEntity("Sargsh112","KingShield",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
Actions.TakeObject(pers.Name,"Sargsh112")
pers.ActionAreaMin=pow( 2,8 ) # Primary Area
pers.ActionAreaMax=pow( 2,9 ) # Secondary Area
EnemyTypes.EnemyDefaultFuncs(pers)
pers.Data=ExTypes.KingSkeleton(pers)
pers.Data.PutOnCrown("Sarg2")
darfuncs.HideBadGuy(pers.Name)
pers.Data.OldImDeadFunc=pers.ImDeadFunc
pers.ImDeadFunc=KingSkelDead


###### Sallys

pers=Bladex.CreateEntity("Salamander_770","Salamander",82686,-1887,141709, "Person")
pers.Scale=1.0
pers.Angle=1.8984270175
pers.Level=15
EnemyTypes.EnemyDefaultFuncs(pers)
darfuncs.HideBadGuy(pers.Name)


pers=Bladex.CreateEntity("Salamander_771","Salamander",73174,-1887,161658, "Person")
pers.Scale=1.0
pers.Angle=1.8984270175
pers.Level=16
EnemyTypes.EnemyDefaultFuncs(pers)
darfuncs.HideBadGuy(pers.Name)

      
pers=Bladex.CreateEntity("Salamander_772","Salamander",54434,-1887,154980, "Person")
pers.Scale=1.0
pers.Angle=1.8984270175
pers.Level=17
EnemyTypes.EnemyDefaultFuncs(pers)
darfuncs.HideBadGuy(pers.Name)


########## Gate Orks

pers=Bladex.CreateEntity("Great_Ork_131","Great_Ork",64527.0285171,-5087.66520253,56227.5096973, "Person")
pers.Scale=1.0
pers.Angle=1.23963832039
pers.Level=11
o=Bladex.CreateEntity ("Orksword_132", "Orksword", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name, "Orksword_132")
o=Bladex.CreateEntity ("Escudo6_133", "Escudo6", 0,0,0)
ItemTypes.ItemDefaultFuncs(o)
Sparks.MakeShield("Escudo6_133")
Actions.TakeObject(pers.Name, "Escudo6_133")
pers.ActionAreaMin=pow( 2,0 ) # Primary Area
pers.ActionAreaMax=pow( 2,1 ) # Secondary Area
EnemyTypes.EnemyDefaultFuncs(pers)
darfuncs.HideBadGuy("Great_Ork_131")
pers.Data.OldImDeadFunc=pers.ImDeadFunc
pers.ImDeadFunc=GateOrksDead


pers=Bladex.CreateEntity("Great_Ork_145","Great_Ork",53756.1774473,-5087.6652122,56208.1288957, "Person")
pers.Scale=1.0
pers.Angle=4.16375856964
pers.Level=10
o=Bladex.CreateEntity ("Hacha6_149", "Hacha6", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name, "Hacha6_149")
o=Bladex.CreateEntity ("Escudo7_147", "Escudo7", 0,0,0)
ItemTypes.ItemDefaultFuncs(o)
Sparks.MakeShield("Escudo7_147")
Actions.TakeObject(pers.Name, "Escudo7_147")
pers.ActionAreaMin=pow( 2,0 ) # Primary Area
pers.ActionAreaMax=pow( 2,1 ) # Secondary Area
EnemyTypes.EnemyDefaultFuncs(pers)
darfuncs.HideBadGuy("Great_Ork_145")
pers.Data.OldImDeadFunc=pers.ImDeadFunc
pers.ImDeadFunc=GateOrksDead


pers=Bladex.CreateEntity("Ork_52","Ork",55000,-5118,40000, "Person")
pers.Scale=1.0
pers.Angle=0.143695769241
pers.Level=16
EnemyTypes.EnemyDefaultFuncs(pers)
o=Bladex.CreateEntity ("Orksword_53", "Orksword", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name, "Orksword_53")
o=Bladex.CreateEntity ("Escudo3_54", "Escudo3", 0,0,0)
ItemTypes.ItemDefaultFuncs(o)
Sparks.MakeShield("Escudo3_54")
Actions.TakeObject(pers.Name, "Escudo3_54")
pers.SetMesh("Gold_Ork")
darfuncs.HideBadGuy("Ork_52")
pers.Data.OldImDeadFunc=pers.ImDeadFunc
pers.ImDeadFunc=GoldOrkCaptainDead


###### Great Demon

pers=Bladex.CreateEntity("greatdemon1","Great_Demon", 130500, 8500, 121000,"Person")
pers.Angle=3
pers.Level=9
EnemyTypes.EnemyDefaultFuncs(pers)
pers.SetOnFloor()
darfuncs.HideBadGuy("greatdemon1")
pers.Data.OldImDeadFunc=pers.ImDeadFunc
pers.ImDeadFunc=GreatDemonDED


##### First Critters

o=Bladex.CreateEntity("Cos_154","Cos",33845.2461774,7683.36709315,63644.307376, "Person")
o.Scale=1.0
o.Angle=1
o.Level=9
EnemyTypes.EnemyDefaultFuncs(o)
darfuncs.HideBadGuy("Cos_154")

o=Bladex.CreateEntity("Cos_155","Cos",34445.2462714,7683.36709315,65444.3074381, "Person")
o.Scale=1.0
o.Angle=3.3835305467
o.Level=3
EnemyTypes.EnemyDefaultFuncs(o)
darfuncs.HideBadGuy("Cos_155")

o=Bladex.CreateEntity("Cos_157","Cos",18700.8399077,6683.36709315,60944.0372087, "Person")
o.Scale=1.0
o.Angle=6.08048764764
o.Level=1
o.Life=8.0
EnemyTypes.EnemyDefaultFuncs(o)
darfuncs.HideBadGuy("Cos_157")

o=Bladex.CreateEntity("Cos_156","Cos",16900.5294231,7683.36709315,65344.5874032, "Person")
o.Scale=1.0
o.Angle=3.73905549468
o.Level=1
o.Life=8.0
EnemyTypes.EnemyDefaultFuncs(o)
darfuncs.HideBadGuy("Cos_156")


###### Uground Zombies

pers=Bladex.CreateEntity("Knight_Zombie_1111","Knight_Zombie",-25964.6192777,8027.70357254,-26315.4374835, "Person")
pers.Scale=1.0
pers.Angle=5.93008370276
pers.Level=14
pers.Data=ExTypes.FlammableZombie(pers)
o=Bladex.CreateEntity ("Hacha4_1112", "Hacha4", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject("Knight_Zombie_1111", "Hacha4_1112")
darfuncs.HideBadGuy("Knight_Zombie_1111")


pers=Bladex.CreateEntity("Knight_Zombie_1111a","Knight_Zombie",-39400,8027.70357254,-24250, "Person")
pers.Scale=1.0
pers.Angle=5.93008370276
pers.Level=14
pers.Data=ExTypes.FlammableZombie(pers)
o=Bladex.CreateEntity ("Hacha4_1112a", "Hacha4", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject("Knight_Zombie_1111a", "Hacha4_1112a")
darfuncs.HideBadGuy("Knight_Zombie_1111a")



pers=Bladex.CreateEntity("Knight_Zombie_1111b","Knight_Zombie",-47330,8027.70357254,-23680, "Person")
pers.Scale=1.0
pers.Angle=5.93008370276
pers.Level=16
pers.Data=ExTypes.FlammableZombie(pers)
o=Bladex.CreateEntity ("Hacha4_1112b", "Hacha4", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject("Knight_Zombie_1111b", "Hacha4_1112b")
darfuncs.HideBadGuy("Knight_Zombie_1111b")


##### Arena Knights

pers=Bladex.CreateEntity("ArenaKnight1","Dark_Knight",36000,-1000,-18000, "Person")
pers.Scale=1.0
pers.Angle=1
pers.Level=16
EnemyTypes.EnemyDefaultFuncs(pers)
o=Bladex.CreateEntity ("arenawp1", "Cimitarra", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject("ArenaKnight1", "arenawp1")
o=Bladex.CreateEntity ("arenash1", "Escudo4", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject("ArenaKnight1", "arenash1")
darfuncs.HideBadGuy("ArenaKnight1")
pers.Data.OldImDeadFunc=pers.ImDeadFunc
pers.ImDeadFunc=ArenaKnightDED


pers=Bladex.CreateEntity("ArenaKnight2","Dark_Knight",31000,-1000,-2700, "Person")
pers.Scale=1.0
pers.Angle=2
pers.Level=17
EnemyTypes.EnemyDefaultFuncs(pers)
o=Bladex.CreateEntity ("arenawp2", "EgyptSword", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject("ArenaKnight2", "arenawp2")
o=Bladex.CreateEntity ("arenash2", "Escudo1", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject("ArenaKnight2", "arenash2")
darfuncs.HideBadGuy("ArenaKnight2")
pers.Data.OldImDeadFunc=pers.ImDeadFunc
pers.ImDeadFunc=ArenaKnightDED


pers=Bladex.CreateEntity("ArenaKnight3","Knight_Traitor",50000,-1000,-10000, "Person")
pers.Scale=1.0
pers.Angle=1.5
pers.Level=17
EnemyTypes.EnemyDefaultFuncs(pers)
o=Bladex.CreateEntity ("arenawp3", "MazaDoble", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject("ArenaKnight3", "arenawp3")
o=Bladex.CreateEntity ("arenash3", "Escudo8", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject("ArenaKnight3", "arenash3")
darfuncs.HideBadGuy("ArenaKnight3")  
pers.Data.OldImDeadFunc=pers.ImDeadFunc
pers.ImDeadFunc=ArenaKnightDED   


##### Near Cloisters

pers=Bladex.CreateEntity("ork2","Great_Ork",13000, -1118, 51250,"Person")
pers.Angle=2.3
pers.Level=14
o=Bladex.CreateEntity("OrkClub","Varita7", 13000, -700, 50000,"Weapon")
o.Scale=1
o.Orientation=0.727026,-0.015552,-0.686425,0.003516
o.Data=def_class.WierdWeapons(o)
darfuncs.SetHint(o,"Ork Club")
Actions.TakeObject(pers.Name,"OrkClub")
EnemyTypes.EnemyDefaultFuncs(pers)
pers.SetOnFloor()
darfuncs.HideBadGuy("ork2")

###### Near Archery Range

pers=Bladex.CreateEntity("Mino44","Minotaur",-34000, -1118, 24250,"Person")
pers.Level=16
pers.Angle=4.5
o=Bladex.CreateEntity("Nobbler44","Mazapiedra",0,0,0,"Weapon")
Actions.TakeObject(pers.Name,"Nobbler44")
EnemyTypes.EnemyDefaultFuncs(pers)
pers.SetOnFloor()
darfuncs.HideBadGuy(pers.Name)
pers.Data.OldImDeadFunc=pers.ImDeadFunc
pers.ImDeadFunc=Mino44DED   


##### Bottom of Stairs in water

pers=Bladex.CreateEntity("Troll_Dark_55","Troll_Dark",-61914,10016,-11298, "Person")
pers.Scale=1.0
pers.Angle=0.0105520942293
pers.Level=10
EnemyTypes.EnemyDefaultFuncs(pers)
o=Bladex.CreateEntity ("Hacha_56", "Hachacarnicero", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject("Troll_Dark_55", "Hacha_56")
darfuncs.HideBadGuy(pers.Name)


###### Archers

pers=Bladex.CreateEntity("topork","Ork", -9446, -12083, -37031,"Person")
pers.Angle=2.25
pers.Level=9
pers.SetOnFloor()
bowtop=Bladex.CreateEntity("toporkbow","Arco",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(bowtop)
Actions.TakeObject(pers.Name,bowtop.Name)
quivertop=Bladex.CreateEntity("toporkquiver","Carcaj",0,0,0,"Physic")
QuiverTypes.QuiverTypeFuncs(quivertop)
quivertop.Data.SetNumberOfArrows(10, pers.Name)
Actions.TakeObject(pers.Name,quivertop.Name)
swordtop=Bladex.CreateEntity("toporksword","Maza3",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(swordtop)
Actions.TakeObject(pers.Name,swordtop.Name)
EnemyTypes.EnemyDefaultFuncs(pers)
darfuncs.HideBadGuy("topork")


pers=Bladex.CreateEntity("topork2","Ork",-14236,-10500,13422,"Person")
pers.Angle=3.0776426329
pers.Level=9
pers.SetOnFloor()
bowtop=Bladex.CreateEntity("toporkbow2","Arco",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(bowtop)
Actions.TakeObject(pers.Name,bowtop.Name)
quivertop=Bladex.CreateEntity("toporkquiver2","Carcaj",0,0,0,"Physic")
QuiverTypes.QuiverTypeFuncs(quivertop)
quivertop.Data.SetNumberOfArrows(10, pers.Name)
Actions.TakeObject(pers.Name,quivertop.Name)
swordtop=Bladex.CreateEntity("toporksword21","Espadaromana",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(swordtop)
Actions.TakeObject(pers.Name,swordtop.Name)
pers.ActionAreaMin=pow( 2,6 ) # Primary Area
pers.ActionAreaMax=pow( 2,7 ) # Secondary Area
EnemyTypes.EnemyDefaultFuncs(pers)
darfuncs.HideBadGuy("topork2")


pers=Bladex.CreateEntity("topork22","Ork",-21700,-10500,13422,"Person")
pers.Angle=3.0776426329
pers.Level=9
pers.SetOnFloor()
bowtop=Bladex.CreateEntity("toporkbow22","Arco",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(bowtop)
Actions.TakeObject(pers.Name,bowtop.Name)
quivertop=Bladex.CreateEntity("toporkquiver22","Carcaj",0,0,0,"Physic")
QuiverTypes.QuiverTypeFuncs(quivertop)
quivertop.Data.SetNumberOfArrows(10, pers.Name)
Actions.TakeObject(pers.Name,quivertop.Name)
swordtop=Bladex.CreateEntity("toporksword211","Espadaromana",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(swordtop)
Actions.TakeObject(pers.Name,swordtop.Name)
pers.ActionAreaMin=pow( 2,6 ) # Primary Area
pers.ActionAreaMax=pow( 2,7 ) # Secondary Area
EnemyTypes.EnemyDefaultFuncs(pers)
darfuncs.HideBadGuy("topork22")


###### Top Deck Knights

pers=Bladex.CreateEntity("Dark_Knight_58","Dark_Knight",47902.1826877,-17949.2888249,-17677.2634979, "Person")
pers.Scale=1.0
pers.Angle=0.61021318262
pers.Level=15
EnemyTypes.EnemyDefaultFuncs(pers)
o=Bladex.CreateEntity ("Espadaromana_59", "Espadaromana", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name, "Espadaromana_59")
o=Bladex.CreateEntity ("KingShield_60", "KingShield", 0,0,0)
ItemTypes.ItemDefaultFuncs(o)
Sparks.MakeShield("KingShield_60")
Actions.TakeObject(pers.Name, "KingShield_60")
Actions.TakeObject(pers.Name, "keyg36")
darfuncs.HideBadGuy("Dark_Knight_58")


pers=Bladex.CreateEntity("Dark_Knight_58a","Dark_Knight",-3500,-18088,-100, "Person")
pers.Scale=1.0
pers.Angle=0.6
pers.Level=17
EnemyTypes.EnemyDefaultFuncs(pers)
o=Bladex.CreateEntity ("Wepon58a", "Espadaromana", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name, "Wepon58a")
o=Bladex.CreateEntity ("Shield58a", "Escudo2", 0,0,0)
ItemTypes.ItemDefaultFuncs(o)
Sparks.MakeShield("Shield58a")
Actions.TakeObject(pers.Name, "Shield58a")
darfuncs.HideBadGuy("Dark_Knight_58a")


pers=Bladex.CreateEntity("Dark_Knight_58b","Dark_Knight",-1850,-18088,2900, "Person")
pers.Scale=1.0
pers.Angle=0.61021318262
pers.Level=17
EnemyTypes.EnemyDefaultFuncs(pers)
o=Bladex.CreateEntity ("Wepon58b", "EgyptSword", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name, "Wepon58b")
o=Bladex.CreateEntity ("Shield58b", "Escudo5", 0,0,0)
ItemTypes.ItemDefaultFuncs(o)
Sparks.MakeShield("Shield58b")
Actions.TakeObject(pers.Name, "Shield58b")
o=Bladex.CreateEntity ("Pocima200_58b", "Pocima200", 0,0,0)
o.Static=0
o.Solid=1
pocimac.CreatePotion("Pocima200_58b")
Actions.TakeObject(pers.Name, "Pocima200_58b")
darfuncs.HideBadGuy("Dark_Knight_58b")


pers=Bladex.CreateEntity("Sarg1","Knight_N",-2640, -18000, -21979,"Person")
pers.Angle=4
pers.Level=17
o=Bladex.CreateEntity("Sargwp111","Espadaromana",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
Actions.TakeObject(pers.Name,"Sargwp111")
o=Bladex.CreateEntity("Sargsh111","Escudo3",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
Actions.TakeObject(pers.Name,"Sargsh111")
pers.SetMesh("Dark_Knight")
pers.Data=ExTypes.Super_Knt(pers)
darfuncs.HideBadGuy(pers.Name)


##### Stores Ork

pers=Bladex.CreateEntity("Storesork1","Great_Ork",47000,-1118,-46500, "Person")
pers.Scale=1.0
pers.Angle=3
pers.Level=16
EnemyTypes.EnemyDefaultFuncs(pers)
o=Bladex.CreateEntity ("nobbler1", "Garrote2", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject("Storesork1", "nobbler1")
o=Bladex.CreateEntity ("shield101", "Escudo9", 0,0,0)
ItemTypes.ItemDefaultFuncs(o)
Sparks.MakeShield("shield101")
Actions.TakeObject("Storesork1", "shield101")
Actions.TakeObject("Storesork1", "key5")
darfuncs.HideBadGuy("Storesork1")


###### East Courtyard

pers=Bladex.CreateEntity("Ork_298","Ork",62788,-984,-37500, "Person")
pers.Scale=1.0
pers.Angle=2.74
pers.Level=13
pers.ActionAreaMin=pow( 2,14 ) # Primary Area
pers.ActionAreaMax=pow( 2,15 ) # Secondary Area
EnemyTypes.EnemyDefaultFuncs(pers)
o=Bladex.CreateEntity ("Hacha5_299", "Hacha5", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name, "Hacha5_299")
pers.SetMesh("Gold_Ork")
pers.AddBayPoint=62788,-984,-37500
pers.AddBayPoint=63260,-985,16000


pers=Bladex.CreateEntity("Ork_395","Ork",58888,-984,9439, "Person")
pers.Scale=1.0
pers.Angle=5.49
pers.Level=13
pers.ActionAreaMin=pow( 2,14 ) # Primary Area
pers.ActionAreaMax=pow( 2,15 ) # Secondary Area
EnemyTypes.EnemyDefaultFuncs(pers)
o=Bladex.CreateEntity ("EgyptSword_396", "EgyptSword", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name, "EgyptSword_396")
o=Bladex.CreateEntity ("Escudo4_397", "Escudo4", 0,0,0)
ItemTypes.ItemDefaultFuncs(o)
Sparks.MakeShield("Escudo4_397")
Actions.TakeObject(pers.Name, "Escudo4_397")
pers.SetMesh("Gold_Ork")

pers.AddBayPoint=58888,-984,9439
pers.AddBayPoint=66240,-985,900
pers.AddBayPoint=58400,-985,-10120
pers.AddBayPoint=69500,-985,-30000
pers.AddBayPoint=58750,-985,-30000
pers.AddBayPoint=63540,-985,-14450


pers=Bladex.CreateEntity("Ork_395a","Ork",70550,-984.911536547,20000, "Person")
pers.Scale=1.0
pers.Angle=2.25
pers.Level=14
EnemyTypes.EnemyDefaultFuncs(pers)
pers.ActionAreaMin=pow( 2,14 ) # Primary Area
pers.ActionAreaMax=pow( 2,15 ) # Secondary Area
o=Bladex.CreateEntity ("wp395a", "Espadaelfica", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name, "wp395a")
o=Bladex.CreateEntity ("sh395a", "Escudo7", 0,0,0)
ItemTypes.ItemDefaultFuncs(o)
Sparks.MakeShield("sh395a")
Actions.TakeObject(pers.Name, "sh395a")
pers.SetMesh("Dark_Knight")
darfuncs.HideBadGuy("Ork_395a")

######
pers=Bladex.CreateEntity("Ork_405","Ork",46000,-13098,29934, "Person")
pers.Scale=1.0
pers.Angle=0.0
pers.Level=11
EnemyTypes.EnemyDefaultFuncs(pers)
o=Bladex.CreateEntity ("Espadaelfica_406", "Espadaelfica", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name, "Espadaelfica_406")
o=Bladex.CreateEntity ("orkbow36", "Arco", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name, "orkbow36")
o=Bladex.CreateEntity ("quiver36", "Carcaj", 0,0,0, "Weapon")
QuiverTypes.QuiverTypeFuncs(o)
Actions.TakeObject(pers.Name, "quiver36")
pers.ActionAreaMin=pow( 2,2 ) # Primary Area
pers.ActionAreaMax=pow( 2,3 ) # Secondary Area


pers=Bladex.CreateEntity("Ork_4051","Ork",50537,-13098,30548, "Person")
pers.Scale=1.0
pers.Angle=0.12
pers.Level=11
EnemyTypes.EnemyDefaultFuncs(pers)
o=Bladex.CreateEntity ("Espadaelfica_4061", "Espadaelfica", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name, "Espadaelfica_4061")
o=Bladex.CreateEntity ("orkbow361", "Arco", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name, "orkbow361")
o=Bladex.CreateEntity ("quiver361", "Carcaj", 0,0,0, "Weapon")
QuiverTypes.QuiverTypeFuncs(o)
Actions.TakeObject(pers.Name, "quiver361")
pers.ActionAreaMin=pow( 2,2 ) # Primary Area
pers.ActionAreaMax=pow( 2,3 ) # Secondary Area



pers=Bladex.CreateEntity("Ork_4052","Ork",68226,-13098,30020, "Person")
pers.Scale=1.0
pers.Angle=0.12
pers.Level=9
EnemyTypes.EnemyDefaultFuncs(pers)
o=Bladex.CreateEntity ("Espadaelfica_4062", "Espadaelfica", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name, "Espadaelfica_4062")
o=Bladex.CreateEntity ("orkbow362", "Arco", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name, "orkbow362")
o=Bladex.CreateEntity ("quiver362", "CarcajEnvenenado", 0,0,0, "Weapon")
QuiverTypes.QuiverTypeFuncs(o)
Actions.TakeObject(pers.Name, "quiver362")
pers.ActionAreaMin=pow( 2,2 ) # Primary Area
pers.ActionAreaMax=pow( 2,3 ) # Secondary Area


#### BOSS

pers=Bladex.CreateEntity("Great_Ork_387","Great_Ork",73668.8100781,-910.302525836,-29559.0926487, "Person")
pers.Scale=1.0
pers.Angle=2.0
pers.Level=19
EnemyTypes.EnemyDefaultFuncs(pers)
pers.ActionAreaMin=pow( 2,14 ) # Primary Area
pers.ActionAreaMax=pow( 2,15 ) # Secondary Area
o=Bladex.CreateEntity ("Espadaromana_390", "Cimitarra", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject("Great_Ork_387", "Espadaromana_390")
o=Bladex.CreateEntity ("Escudo7_391", "Escudo4", 0,0,0)
ItemTypes.ItemDefaultFuncs(o)
Sparks.MakeShield("Escudo7_391")
Actions.TakeObject("Great_Ork_387", "Escudo7_391")
darfuncs.HideBadGuy("Great_Ork_387")
pers.Data.OldImDeadFunc=pers.ImDeadFunc
pers.ImDeadFunc=BossOrkDED

####### Rest Room

pers=Bladex.CreateEntity("Ork_645","Ork",33220.4486248,-17984.911859,10460.6967792, "Person")
pers.Scale=1.0
pers.Angle=5.9
pers.Level=11
EnemyTypes.EnemyDefaultFuncs(pers)
o=Bladex.CreateEntity ("Hacha5_646", "Hacha5", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name,"Hacha5_646")
darfuncs.HideBadGuy(pers.Name)


pers=Bladex.CreateEntity("Ork_641","Ork",35176.4633272,-17984.9115366,16055.9768062, "Person")
pers.Scale=1.0
pers.Angle=2.82628359515
pers.Level=11
EnemyTypes.EnemyDefaultFuncs(pers)
o=Bladex.CreateEntity ("Maza2_642", "Maza2", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name,"Maza2_642")
o=Bladex.CreateEntity ("Escudo7_644", "Escudo7", 0,0,0)
ItemTypes.ItemDefaultFuncs(o)
Sparks.MakeShield("Escudo7_644")
Actions.TakeObject(pers.Name,"Escudo7_644")
darfuncs.HideBadGuy(pers.Name)


##### Bell Tower

pers=Bladex.CreateEntity("BelltowerOrk","Ork",26500,-12112,-61000, "Person")
pers.Scale=1.0
pers.Angle=2.74099954536
pers.Level=10
pers.ActionAreaMin=pow( 2,16 ) # Primary Area
pers.ActionAreaMax=pow( 2,17 ) # Secondary Area
EnemyTypes.EnemyDefaultFuncs(pers)
o=Bladex.CreateEntity ("swordcliff1", "Orksword", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name, "swordcliff1")
pers.SetMesh("Gold_Ork")
pers.AddBayPoint=26500,-12112,-61000
pers.AddBayPoint=26710,-12612,-70991
          
          
##### Cliff Walk

pers=Bladex.CreateEntity("Orkcliff1","Ork",57450,-5112,-62200, "Person")
pers.Scale=1.0
pers.Angle=3
pers.Level=16
pers.ActionAreaMin=pow( 2,12 ) # Primary Area
pers.ActionAreaMax=pow( 2,13 ) # Secondary Area
EnemyTypes.EnemyDefaultFuncs(pers)
o=Bladex.CreateEntity ("swordcliff1a", "Maza3", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name, "swordcliff1a")
o=Bladex.CreateEntity ("Escudo4cliff1", "Escudo4", 0,0,0)
ItemTypes.ItemDefaultFuncs(o)
Sparks.MakeShield("Escudo4cliff1")
Actions.TakeObject(pers.Name,"Escudo4cliff1")
pers.SetMesh("Dark_Ork")
darfuncs.HideBadGuy(pers.Name)


pers=Bladex.CreateEntity("Orkcliff2","Ork",21250,-5112,-62500, "Person")
pers.Scale=1.0
pers.Angle=2.74099954536
pers.Level=11
pers.ActionAreaMin=pow( 2,12 ) # Primary Area
pers.ActionAreaMax=pow( 2,13 ) # Secondary Area
EnemyTypes.EnemyDefaultFuncs(pers)
o=Bladex.CreateEntity ("swordcliff2", "Hacha5", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name, "swordcliff2")
darfuncs.HideBadGuy(pers.Name)


pers=Bladex.CreateEntity("Orkcliff3","Ork",8750,-5112,-62250, "Person")
pers.Scale=1.0
pers.Angle=4
pers.Level=12
pers.ActionAreaMin=pow( 2,12 ) # Primary Area
pers.ActionAreaMax=pow( 2,13 ) # Secondary Area
EnemyTypes.EnemyDefaultFuncs(pers)
o=Bladex.CreateEntity ("swordcliff3", "Orksword", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name, "swordcliff3")
darfuncs.HideBadGuy(pers.Name)

########### The one that gets an elephant on his head

pers=Bladex.CreateEntity("Minotaur_773","Minotaur",23052,0,181711, "Person")
pers.Scale=1.0
pers.Angle=2.7
o=Bladex.CreateEntity("Bignobbler1","Hachacarnicero",0,0,0,"Weapon")
Actions.TakeObject(pers.Name,"Bignobbler1")
pers.Level=6
EnemyTypes.EnemyDefaultFuncs(pers)
darfuncs.HideBadGuy(pers.Name)

####### Guards on North Gatehouse
	
pers=Bladex.CreateEntity("Guardork1","Ork",70825,-5118,29174, "Person")
pers.Scale=1.0
pers.Angle=2.82628359515
pers.Level=9
EnemyTypes.EnemyDefaultFuncs(pers)
o=Bladex.CreateEntity ("orkwep1", "Garropin", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name,"orkwep1")
darfuncs.HideBadGuy(pers.Name)


pers=Bladex.CreateEntity("Guardork2","Ork",68000,-5118,26977, "Person")
pers.Scale=1.0
pers.Angle=1.5
pers.Level=14
EnemyTypes.EnemyDefaultFuncs(pers)
o=Bladex.CreateEntity ("orkwep2", "HookSword", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name,"orkwep2")
o=Bladex.CreateEntity ("orkshld2", "Escudo5", 0,0,0)
ItemTypes.ItemDefaultFuncs(o)
Sparks.MakeShield("orkshld2")
Actions.TakeObject(pers.Name,"orkshld2")
pers.SetMesh("Gold_Ork")
darfuncs.HideBadGuy(pers.Name)


pers=Bladex.CreateEntity("Guardork3","Ork",50000,-5118,28625, "Person")
pers.Scale=1.0
pers.Angle=4.6
pers.Level=11
EnemyTypes.EnemyDefaultFuncs(pers)
o=Bladex.CreateEntity ("orkwep3", "Sablazo", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name,"orkwep3")
ItemTypes.ItemDefaultFuncs(o)
darfuncs.HideBadGuy(pers.Name)


###### Top of stairs nesr armoury door

pers=Bladex.CreateEntity("Guardork70","Ork",-41250,-10618,28250, "Person")
pers.Scale=1.0
pers.Angle=2.82
pers.Level=17
EnemyTypes.EnemyDefaultFuncs(pers)
o=Bladex.CreateEntity ("orkwep70", "Hacha3", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name,"orkwep70")
ItemTypes.ItemDefaultFuncs(o)
darfuncs.HideBadGuy(pers.Name)


##### First Magic Ork

pers=Bladex.CreateEntity("MagicOrk0","Great_Ork",0,0,0,"Person")
pers.Angle=0
pers.Level=13
o=Bladex.CreateEntity("magwp","Martillo2",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
Actions.TakeObject(pers.Name,"magwp")
pers.Data=ExTypes.MagicOrk(pers)
darfuncs.HideBadGuy("MagicOrk0")
pers.Data.OldImDeadFunc=pers.ImDeadFunc
pers.ImDeadFunc=MagOrkDED


###### Archer Orks in North Gatehouse

pers=Bladex.CreateEntity("tknt1","Ork",-50000, -17500, 2750,"Person")
pers.Angle=4
pers.Level=9
EnemyTypes.EnemyDefaultFuncs(pers)
pers.ActionAreaMin=pow(2,4)
pers.ActionAreaMax=pow(2,5)
pers.SetOnFloor()
o=Bladex.CreateEntity ("tkntwp1", "Espadaelfica", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name, "tkntwp1")
o=Bladex.CreateEntity ("tkntbw1", "Arco", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name, "tkntbw1")
o=Bladex.CreateEntity ("tkntq1", "Carcaj", 0,0,0, "Weapon")
QuiverTypes.QuiverTypeFuncs(o)
Actions.TakeObject(pers.Name, "tkntq1")



pers=Bladex.CreateEntity("tknt2","Ork",-30500, -17500, -10000,"Person")
pers.Angle=4
pers.Level=9
EnemyTypes.EnemyDefaultFuncs(pers)
pers.ActionAreaMin=pow(2,4)
pers.ActionAreaMax=pow(2,5)
pers.SetOnFloor()
o=Bladex.CreateEntity ("tkntwp2", "Katana", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name, "tkntwp2")
o=Bladex.CreateEntity ("tkntbw2", "Arco", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name, "tkntbw2")
o=Bladex.CreateEntity ("tkntq2", "Carcaj", 0,0,0, "Weapon")
QuiverTypes.QuiverTypeFuncs(o)
Actions.TakeObject(pers.Name, "tkntq2")
darfuncs.HideBadGuy("tknt2")                        


pers=Bladex.CreateEntity("tknt3","Ork",-50000, -17500, -19000,"Person")
pers.Angle=4
pers.Level=9
pers.ActionAreaMin=pow(2,4)
pers.ActionAreaMax=pow(2,5)
EnemyTypes.EnemyDefaultFuncs(pers)
pers.SetOnFloor()
o=Bladex.CreateEntity ("tkntwp3", "Hacha4", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name, "tkntwp3")
o=Bladex.CreateEntity ("tkntbw3", "Arco2", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name, "tkntbw3")
o=Bladex.CreateEntity ("tkntq3", "Carcaj", 0,0,0, "Weapon")
QuiverTypes.QuiverTypeFuncs(o)
Actions.TakeObject(pers.Name, "tkntq3")

######## Knights on Top Deck

pers=Bladex.CreateEntity("Knight001","Knight_Traitor",-56750,-17500,-8250, "Person")
pers.Scale=1.0
pers.Angle=5.75500391617
pers.Level=17
EnemyTypes.EnemyDefaultFuncs(pers)
o=Bladex.CreateEntity ("Axe001", "Hacha3", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject("Knight001", "Axe001")
o=Bladex.CreateEntity ("Shield001", "Escudo4", 0,0,0)
ItemTypes.ItemDefaultFuncs(o)                                   
Sparks.MakeShield("Shield001")
Actions.TakeObject("Knight001", "Shield001")
darfuncs.HideBadGuy("Knight001")


pers=Bladex.CreateEntity("Knight002","Knight_Traitor",-57750,-17500,-13250, "Person")
pers.Scale=1.0
pers.Angle=3
pers.Level=17
EnemyTypes.EnemyDefaultFuncs(pers)
o=Bladex.CreateEntity ("Sword002", "Hacha3", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject("Knight002", "Sword002")
o=Bladex.CreateEntity ("Shield002", "Escudo3", 0,0,0)
ItemTypes.ItemDefaultFuncs(o)                                   
Sparks.MakeShield("Shield002")
Actions.TakeObject("Knight002", "Shield002")
pers.SendTriggerSectorMsgs=0
darfuncs.HideBadGuy("Knight002")


######## Vamp

pers=Bladex.CreateEntity("Vamp1","Vamp",-60397, -1000, -43625,"Person")
pers.Angle=1.5
pers.Scale=1
pers.Level=15
o=Bladex.CreateEntity("vampwp1","VampWeapon",0,0,0,"Weapon")
o.Scale=1
ItemTypes.ItemDefaultFuncs (o)
o.SelfIlum=0.3
o=Bladex.CreateEntity("vampsh1","VampShield",0,0,0,"Weapon")
o.Scale=1
ItemTypes.ItemDefaultFuncs (o)
o.SelfIlum=0.3
Actions.TakeObject(pers.Name,"vampwp1")
Actions.TakeObject(pers.Name,"vampsh1")
pers.Data=ExTypes.FIVamp(pers)
pers.Data.DamageFactorNone=0.15
pers.Data.DamageFactorLight=0.25
pers.Data.DamageFactorHeavy=0.35
pers.Data.FDefense = 4.0
pers.SetOnFloor()
pers.SelfIlum=0.3
pers.Data.OldImDeadFunc=pers.ImDeadFunc
pers.ImDeadFunc=Vamp1Dead
darfuncs.HideBadGuy("Vamp1")

Ontake.AddOnTakeEvent("Magicamulet2",  Cut3)


##### Gatekeeper

chaosk10=Bladex.CreateEntity("ChaosK10", "ChaosKnight", 131000, -3500, -52500)
chaosk10.Person=1
chaosk10.Angle=1.5
chaosk10.Level=17
chaosk10.Data=ExTypes.Pro3ChaosKnight(chaosk10)
chaosk10.Data.DamageFactorNone=0.15
chaosk10.Data.DamageFactorLight=0.35
chaosk10.Data.DamageFactorHeavy=0.35
chaosk10.Data.PrepareWeapons("Espadon", "Escudon")
chaosk10.Data.Deathfunc=ChaosKnightDED
chaosk10.SetOnFloor()
darfuncs.HideBadGuy(chaosk10.Name)


########## Falling Orks in Key Room

pers=Bladex.CreateEntity("Ork_771a","Ork",87928,-14110,-49300, "Person")
pers.Scale=1.0
pers.Angle=3
pers.Level=13
EnemyTypes.EnemyDefaultFuncs(pers)
o=Bladex.CreateEntity ("Maza2_771a", "Maza2", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name,"Maza2_771a")
darfuncs.HideBadGuy(pers.Name)


pers=Bladex.CreateEntity("Ork_771b","Ork",81200,-14110,-54950, "Person")
pers.Scale=1.0
pers.Angle=4.5
pers.Level=14
EnemyTypes.EnemyDefaultFuncs(pers)
o=Bladex.CreateEntity ("Maza2_771b", "Dagesse", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name,"Maza2_771b")
darfuncs.HideBadGuy(pers.Name)
pers.SetMesh("Gold_Ork")

	
####### Forge Roof
	
pers=Bladex.CreateEntity("Troll_Dark_934","Troll_Dark",26000,-10396.8996559,38617.5997647, "Person")
pers.Scale=1.0
pers.Angle=3
pers.Level=13
EnemyTypes.EnemyDefaultFuncs(pers)
o=Bladex.CreateEntity ("Trollchopper2", "Hachacarnicero", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject("Troll_Dark_934", "Trollchopper2")
darfuncs.HideBadGuy(pers.Name)


pers=Bladex.CreateEntity("Orky","Ork",44465,-10112,48135, "Person")
pers.Scale=1.0
pers.Angle=1.5
pers.Level=14
EnemyTypes.EnemyDefaultFuncs(pers)
o=Bladex.CreateEntity ("OrkyWp1", "Hacha3", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name,"OrkyWp1")
darfuncs.HideBadGuy(pers.Name)

######## TV Ork

tvork=Bladex.CreateEntity("Ork_1017","Ork",46365.6632198,-6984.91153696,126586.430896, "Person")
tvork.Scale=1.0
tvork.Angle=4.9
tvork.Level=8
EnemyTypes.EnemyDefaultFuncs(tvork)
o=Bladex.CreateEntity ("Ork_1017wp", "Jarra", 0,0,0, "Weapon")
Actions.TakeObject(tvork.Name,"Ork_1017wp")
ItemTypes.ItemDefaultFuncs(o)
darfuncs.HideBadGuy(tvork.Name)


######## Clay Golems

pers=Bladex.CreateEntity("Gol1","Golem_clay",75500,11000,18250, "Person")
pers.Scale=1.0
pers.Angle=4.5
pers.Level=11
EnemyTypes.EnemyDefaultFuncs(pers)
darfuncs.HideBadGuy("Gol1")

pers=Bladex.CreateEntity("Gol11","Golem_stone",70500,11000,18250, "Person")
pers.Scale=1.0
pers.Angle=4.5
pers.Level=13
EnemyTypes.EnemyDefaultFuncs(pers)
darfuncs.HideBadGuy("Gol11")


####### Skels Underground

pers=Bladex.CreateEntity("Skeleton_1132","Skeleton",11613.26396,6975.3520702,-20105.2235848, "Person")
pers.Scale=1.0
pers.Angle=1.83776870515
pers.Level=13
EnemyTypes.EnemyDefaultFuncs(pers)
o=Bladex.CreateEntity ("Hacha3_1133", "Hacha3", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject("Skeleton_1132", "Hacha3_1133")
darfuncs.HideBadGuy("Skeleton_1132")

pers=Bladex.CreateEntity("Skeleton_1134","Skeleton",13013.26396,6975.3520703,-21305.2235848, "Person")
pers.Scale=1.0
pers.Angle=0.857950278041
pers.Level=11
EnemyTypes.EnemyDefaultFuncs(pers)
o=Bladex.CreateEntity ("Orksword_1135", "Orksword", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject("Skeleton_1134", "Orksword_1135")
darfuncs.HideBadGuy("Skeleton_1134")

######### Trench at side of Arena

pers=Bladex.CreateEntity("Troll_Dark_935","Troll_Dark",11597,6888,-34702, "Person")
pers.Scale=1.0
pers.Angle=1.5
pers.Level=13
EnemyTypes.EnemyDefaultFuncs(pers)
o=Bladex.CreateEntity ("Trollchopper3", "Hachacarnicero", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject("Troll_Dark_935", "Trollchopper3")
darfuncs.HideBadGuy(pers.Name)


###### Ragnar

o=Bladex.CreateEntity("RagnarSword","EspadaMagica3", -58500, -17500, -19000,"Weapon")
o.Scale=1
o.Orientation=0.727026,-0.015552,-0.686425,0.003516
ItemTypes.ItemDefaultFuncs (o)
darfuncs.SetHint(o,"Sword of Ophiuchus")


pers=Bladex.CreateEntity("RedKnight1","Ragnar", -58500, -17500, -20000,"Person")
pers.Angle=0.0
pers.Level=19
pers.ActionAreaMin=pow(2,4)
pers.ActionAreaMax=pow(2,5)
EnemyTypes.EnemyDefaultFuncs(pers)
Actions.TakeObject(pers.Name,"RagnarSword")   
o=Bladex.CreateEntity("Ragnarsh1","Escudo4",0,0,0)
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name,"Ragnarsh1")
darfuncs.HideBadGuy("RedKnight1")


###### More Critters

pers=Bladex.CreateEntity("Cos_1262","Cos",62501.6010606,4683.36709219,-52100.6476743, "Person")
pers.Scale=1.0
pers.Angle=1.38649960131
pers.Level=8
EnemyTypes.EnemyDefaultFuncs(pers)
darfuncs.HideBadGuy("Cos_1262")


pers=Bladex.CreateEntity("Cos_1256","Cos",44239.5630878,4683.36709315,-53737.8132728, "Person")
pers.Scale=1.0
pers.Angle=4.23455729082
pers.Level=9
EnemyTypes.EnemyDefaultFuncs(pers)
darfuncs.HideBadGuy("Cos_1256")


pers=Bladex.CreateEntity("Cos_1257","Cos",61770.4385604,4683.36709315,-47976.7053472, "Person")
pers.Scale=1.0
pers.Angle=3.24094739409
pers.Level=3
EnemyTypes.EnemyDefaultFuncs(pers)
darfuncs.HideBadGuy("Cos_1257")


pers=Bladex.CreateEntity("Cos_1258","Cos",66636.9887417,4683.36711087,-57522.0340638, "Person")
pers.Scale=1.0
pers.Angle=0.910490444928
pers.Level=3
EnemyTypes.EnemyDefaultFuncs(pers)
darfuncs.HideBadGuy("Cos_1258")

pers=Bladex.CreateEntity("Cos_1259","Cos",67636.9887417,4683.36711084,-57522.0340639, "Person")
pers.Scale=1.0
pers.Angle=3.7730683656
pers.Level=4
EnemyTypes.EnemyDefaultFuncs(pers)
darfuncs.HideBadGuy("Cos_1259")

pers=Bladex.CreateEntity("Cos_1260","Cos",73061.0541591,4683.36711087,-57634.8772285, "Person")
pers.Scale=1.0
pers.Angle=0.64694837655
pers.Level=4
EnemyTypes.EnemyDefaultFuncs(pers)
darfuncs.HideBadGuy("Cos_1260")


pers=Bladex.CreateEntity("Cos_1261","Cos",73035.2092423,4683.36709315,-51288.0865631, "Person")
pers.Scale=1.0
pers.Angle=1.72940250595
pers.Level=3
EnemyTypes.EnemyDefaultFuncs(pers)
darfuncs.HideBadGuy("Cos_1261")


########  On Cliff Walk
	
pers=Bladex.CreateEntity("2ork1","Ork",-4580,-2000,-52750, "Person")
pers.Scale=1.0
pers.Angle=4.5
pers.Level=16
EnemyTypes.EnemyDefaultFuncs(pers)
o=Bladex.CreateEntity ("2axe1", "Hacha2", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name, "2axe1")
pers.SetMesh("Dark_Ork")
darfuncs.HideBadGuy("2ork1")

pers=Bladex.CreateEntity("2ork2","Ork",-7326,-3000,-52850, "Person")
pers.Scale=1.0
pers.Angle=3
pers.Level=13
EnemyTypes.EnemyDefaultFuncs(pers)
o=Bladex.CreateEntity ("2axe2", "Hacha4", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name, "2axe2")
darfuncs.HideBadGuy("2ork2")


####### Orks in cave

pers=Bladex.CreateEntity("Ork_1411","Ork",98560,10888,31750, "Person")
pers.Scale=1.0
pers.Angle=3.22438469817
pers.Level=12
EnemyTypes.EnemyDefaultFuncs(pers)
o=Bladex.CreateEntity ("Espadaelfica_1412", "Espadaelfica", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject("Ork_1411", "Espadaelfica_1412")
pers.SetMesh("Gold_Ork")
darfuncs.HideBadGuy("Ork_1411")


pers=Bladex.CreateEntity("Ork_1413","Ork",99676.1961711,9015.08846345,64383.2161905, "Person")
pers.Scale=1.0
pers.Angle=4.89494808081
pers.Level=15
EnemyTypes.EnemyDefaultFuncs(pers)
o=Bladex.CreateEntity ("Espadafilo_1415", "Espadafilo", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject("Ork_1413", "Espadafilo_1415")
o=Bladex.CreateEntity ("Escudo2_1414", "Escudo2", 0,0,0)
ItemTypes.ItemDefaultFuncs(o)
Sparks.MakeShield("Escudo2_1414")
Actions.TakeObject("Ork_1413", "Escudo2_1414")
darfuncs.HideBadGuy("Ork_1413")


##### Extra Orks on return to East Courtyard

pers=Bladex.CreateEntity("OrkX1","Ork",57000,-1000,14340, "Person")
pers.Scale=1.0
pers.Angle=3
pers.Level=18
pers.ActionAreaMin=pow( 2,14 ) # Primary Area
pers.ActionAreaMax=pow( 2,15 ) # Secondary Area
EnemyTypes.EnemyDefaultFuncs(pers)
o=Bladex.CreateEntity ("EspadaelficaX1", "Espadaelfica", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject("OrkX1", "EspadaelficaX1")
pers.SetMesh("Gold_Ork")
darfuncs.HideBadGuy("OrkX1")


pers=Bladex.CreateEntity("OrkX2","Ork",73626,-1000,9010, "Person")
pers.Scale=1.0
pers.Angle=4.5
pers.Level=14
pers.ActionAreaMin=pow( 2,14 ) # Primary Area
pers.ActionAreaMax=pow( 2,15 ) # Secondary Area
EnemyTypes.EnemyDefaultFuncs(pers)
o=Bladex.CreateEntity ("EspadafiloX2", "Espadafilo", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject("OrkX2", "EspadafiloX2")
o=Bladex.CreateEntity ("Escudo2X2", "Escudo3", 0,0,0)
ItemTypes.ItemDefaultFuncs(o)
Sparks.MakeShield("Escudo2X2")
Actions.TakeObject("OrkX2", "Escudo2X2")
pers.SetMesh("Dark_Ork")
darfuncs.HideBadGuy("OrkX2")


######## Ork in Armoury (was a Dwarf)

pers=Bladex.CreateEntity("Lofty1","Great_Ork",-33250, -10500, 15150,"Person")
pers.Angle=4.5
pers.Level=14
o=Bladex.CreateEntity("Lofty1WP","Hacha3",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
Actions.TakeObject(pers.Name,"Lofty1WP")
o=Bladex.CreateEntity("Lofty1SH","Escudo2",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
Actions.TakeObject(pers.Name,"Lofty1SH")
EnemyTypes.EnemyDefaultFuncs(pers)
darfuncs.HideBadGuy(pers.Name)


######## End Metal Golem

pers=Bladex.CreateEntity("Guardian1","Golem_metal",85493.7397566,-3594.68735071,-61633.7051831, "Person")
pers.Scale=1.0
pers.Angle=0
pers.Level=19
EnemyTypes.EnemyDefaultFuncs(pers)
pers.Data.OldImDeadFunc=pers.ImDeadFunc
pers.ImDeadFunc=GuardianDead
darfuncs.HideBadGuy("Guardian1")


####### Barbie

pers=Bladex.CreateEntity("Barbie1","Barbarian_N",63560, -1118, -40644,"Person")
pers.Angle=4.2
pers.Level=13
o=Bladex.CreateEntity("Barbwp111","Hacharrajada",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
Actions.TakeObject(pers.Name,"Barbwp111")
Actions.TakeObject(pers.Name,"Copperkey")
pers.ActionAreaMin=pow( 2,14 ) 
pers.ActionAreaMax=pow( 2,15 ) 
pers.Data=ExTypes.Ultra_Barb(pers)
pers.SetOnFloor()
darfuncs.HideBadGuy(pers.Name)
pers.Data.OldImDeadFunc=pers.ImDeadFunc
pers.ImDeadFunc=BarbieDED
pers.Data.Resistances=copy.copy(CharStats.GetCharResistances("Ultra_Barb"))


###### Dummy Amazon

o=Bladex.CreateEntity("TroncoGrande_1046","TroncoGrande",130045.80174,9103.90995067,120473.313917, Reference.ObjType("TroncoGrande"))
o.Scale=0.6
o.Orientation=(0.707106769085,0.0,0.0,-0.707106769085)
	
pers=Bladex.CreateEntity("Zoe1","Amazon_N",130250, 8800, 120000,"Person")
pers.Angle=9
pers.SetOnFloor()
pers.SetMesh("AmzSkin2")

print "loaded enemies"






