import Sounds
import Bladex
import math





Bladex.AddParticleGType("AguaCpink","WaterParticle",B_PARTICLE_GTYPE_BLEND,60)

for i in range(60):
	r=120
	g=100
	b=150
	a=60
	size=200.0 #500
	Bladex.SetParticleGVal("AguaCpink",i,r,g,b,a,size)


Bladex.AddParticleGType("AguaCgreen","WaterParticle",B_PARTICLE_GTYPE_BLEND,60)

for i in range(60):
	r=35
	g=50
	b=40
	a=60
	size=200.0 #500
	Bladex.SetParticleGVal("AguaCgreen",i,r,g,b,a,size)

	

Bladex.AddParticleGType("AguaC","WaterParticle",B_PARTICLE_GTYPE_BLEND,60)

for i in range(60):
	r=150
	g=160
	b=160
	a=60
	size=200.0 #500
	Bladex.SetParticleGVal("AguaC",i,r,g,b,a,size)
	
	
Bladex.AddParticleGType("AguaCBIG","WaterParticle",B_PARTICLE_GTYPE_BLEND,60)

for i in range(60):
	r=150
	g=160
	b=160
	a=60
	size=500
	Bladex.SetParticleGVal("AguaCBIG",i,r,g,b,a,size)



Bladex.AddParticleGType("Espuma","SmokeParticle",B_PARTICLE_GTYPE_BLEND,10)

for i in range(10):
	aux=(10.0-i)/10.0
	r=90
	g=90
	b=90
	a=255
	size=600.0*math.sqrt(1.0-aux)
	Bladex.SetParticleGVal("Espuma",i,r,g,b,a,size)


Bladex.AddParticleGType("Methane","SmokeParticle",Reference.B_PARTICLE_GTYPE_BLEND,128)

for i in range(128):
	if i>64:
		traux=0.0
	else:
		traux=(64.0-i)/64.0
	aux=(128.0-i)/128.0
	r=110
	g=145
	b=90
	a=150.0*(1.0-traux)**0.5
	size=10.0+aux*1200.0
	Bladex.SetParticleGVal("Methane",i,r,g,b,a,size)

### Bottom of stairs to tunnel

CreateCascada("WaterSpout1","AguaC",(-63000 ,8500 ,-4500 ),(200.0, 0.0, 0.0),(0.0, -1000.0, -3000.0),15)

v1=Bladex.CreateSound("..\\..\\Sounds\\agua-canal.wav","v1")
v1.MaxDistance=20000
v1.MinDistance=2000
v1.Volume=1.0
v1.BaseVolume=1.0
v1.SendNotify=0
v1.Play(-63000 ,8000 ,-5500,-1)


########################################################################################################
##### fountain of life

CreateCascada("LifeFountain","AguaCpink",(75250,-2700,-2800),( 200, 0, 0 ),(-3000, 300, 0.0),15)

v2=Bladex.CreateSound("..\\..\\Sounds\\agua-canal.wav","v2")
v2.MaxDistance=20000
v2.MinDistance=2000
v2.Volume=1.0
v2.BaseVolume=1.0
v2.SendNotify=0
v2.Play(75250,-1000,-2730,-1)

#####################################################################################################
########## fountain of death


CreateCascada("DeathFountain","AguaCgreen",(75250,-2700,-18200),( 200, 0.0, 0 ),(-3000, 300, 0.0),18)

v3=Bladex.CreateSound("..\\..\\Sounds\\agua-canal.wav","v3")
v3.MaxDistance=22000
v3.MinDistance=2000
v3.Volume=1.0
v3.BaseVolume=1.0
v3.SendNotify=0
v3.Play(75250,-1000,-18250,-1)


#################dwarfyard

CreateCascada("Waterspout2","AguaC",(-53689 ,-2000 ,132750 ),(200.0, 0.0, 0.0),(0.0, 2000.0, -4000.0),23)

v5=Bladex.CreateSound("..\\..\\Sounds\\agua-canal.wav","v5")
v5.MaxDistance=25000
v5.MinDistance=2000
v5.Volume=1.3
v5.BaseVolume=1.0
v5.SendNotify=0
v5.Play(-53750 ,-2000 ,131750,-1)


# Big Waterfall

#CreateCascada("BigWaterfall","AguaCBIG",(-70500,6000,-84500),(0, 0, 5000),(3000, 10000, 0),23)

#CreateEspuma("BigWaterfallSpray1",(-67500,13000,-84500),(0, 0, 2500))
#CreateEspuma("BigWaterfallSpray2",(-67500,13000,-82000),(0, 0, 2500))

v6=Bladex.CreateSound("..\\..\\Sounds\\Large-Waterfall.wav","v6")
v6.MaxDistance=30000
v6.MinDistance=2000
v6.Volume=1.0
v6.BaseVolume=1.0
v6.SendNotify=0


print "loaded cascadas"